#!/usr/bin/perl
######################################################################
# SCGI Ver 1.0.0
# iǗj[pXNvgj
# Copyright(C) futomi 2005
# http://www.futomi.com/
######################################################################
use strict;
BEGIN {
	use FindBin qw($Bin);
	chdir $FindBin::Bin;
	use lib "$FindBin::Bin/lib";
	use CGI;
	use CGI::Carp qw(fatalsToBrowser);
	use FCC::Apache::Session;
	use Digest::Perl::MD5;
	use Jcode;
	unless (eval "use Fcntl; 1") {
		print "Content-Type: text/plain\n\n";
		print "FcntlW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
	unless (eval "use DB_File; 1") {
		print "Content-Type: text/plain\n\n";
		print "DB_FileW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
}
my $q = new CGI;
$| = 1;

my $VERSION = '1.0.0';
#Copyright
my $COPYRIGHT = "futomi's CGI Cafe - SCGI $VERSION";
my $COPYRIGHT1 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">futomi\'s CGI Cafe</a>";
my $COPYRIGHT2 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">${COPYRIGHT}</a>";

#CGIt@C̃t@C擾
my $CGI_URL = &GetThisFileName;

#Cookie
my $COOKIE_NAME = 'session';

#ݒf[^擾
my %CONF = &GetConf('./conf/config.cgi');
#e̎擾
my $action = $q->param('a');

#Ǘ҃pX[ho^
if($action eq 'pass_new') {
	&PasswdChange;
}
#ǗID/PWo^ĂȂ΁Aݒʂ\
if($CONF{'ADMIN_ID'} eq '' || $CONF{'PASS'} eq '') {
	&PrintPasswdSetForm;
}

#F
my %cookies = &GetCookie;
my $sid = $cookies{$COOKIE_NAME};
my %session_data;
my $session;
if($action eq 'logon') {
	&LogOn;
} elsif($sid) {
	&SessionAuth($sid, \%session_data);
} else {
	&PrintLogonForm;
}

#
if($action eq '') {
	&PrintParentFrame
} elsif($action eq 'menu') {
	&PrintMenuFrame;
} elsif($action eq 'top') {
	&PrintTopFrame;
} elsif($action eq 'conf_form') {
	&PrintConfForm;
} elsif($action eq 'setconf') {
	my $rebuild_flag = &SetConf;
	&PrintSetConfComplete($rebuild_flag);
} elsif($action eq 'mkindex_form') {
	&PrintMkindexForm;
} elsif($action eq 'mkindex_pre') {
	&PrintMkindexPre;
} elsif($action eq 'test_form') {
	&PrintTestForm;
} elsif($action eq 'edit_result_form') {
	&PrintEditResultForm;
} elsif($action eq 'edit_result') {
	&EditResultHtml;
	&PrintComplete(
		"ݒ肪܂B",
		"ʉʕҏWɖ߂",
		"${CGI_URL}?a=edit_result_form"
	);
} elsif($action eq 'edit_error_form') {
	&PrintEditErrorForm;
} elsif($action eq 'edit_error') {
	&EditErrorHtml;
	&PrintComplete(
		"ݒ肪܂B",
		"G[ʕҏWɖ߂",
		"${CGI_URL}?a=edit_error_form"
	);
} elsif($action eq 'passwd_change_form') {
	&PrintPasswdForm;
} elsif($action eq 'passwd_change') {
	&PasswdChange;
	&PrintPasswdChangeComplete;
} elsif($action eq 'mkform') {
	&PrintSampleForm;
} elsif($action eq 'list') {
	&PrintList;
} elsif($action eq 'help') {
	&PrintHelp;
} elsif($action eq 'license_form') {
	&PrintLicenseForm;
} elsif($action eq 'setlicense') {
	&SetLicense;
	&PrintComplete(
		"CZXo^ݒ肪܂Bw܂āAɗL܂B",
		"CZXo^ʂɖ߂",
		"${CGI_URL}?a=license_form"
	);
} elsif($action eq 'logoff') {
	&LogOff;
} else {
	&ErrorPrint("sȃANZXłB");
}

exit;


##### Tu[` ###################################################

sub SetLicense {
	my @key_list;
	$key_list[0] = $q->param('KEY0');
	$key_list[1] = $q->param('KEY1');
	$key_list[2] = $q->param('KEY2');
	$key_list[3] = $q->param('KEY3');
	for my $key (@key_list) {
		if($key eq '') {
			&ErrorPrint("L[͂ĉB");
		} elsif($key !~ /^[0-9a-z]{4}$/) {
			&ErrorPrint("L[sK؂łB");
		}
	}
	my $license_key = join("\t", @key_list);
	my $license = &DecodeSirialKey($license_key);
	if($license < 100 || $license > 9999) {
		&ErrorPrint("CZXL[܂B");
	} elsif($license < 9999 && $license % 100 > 0) {
		&ErrorPrint("CZXL[܂B");
	}
	open(FILE, ">./conf/license.cgi") or &ErrorPrint("CZXL[o^Ɏs܂B: $!");
	print FILE ${license_key};
	close(FILE);
}

sub PrintLicenseForm {
	my $html = &ReadTemplate("./template/admin/license.html");
	my $license_key = &ReadTextFile("./conf/license.cgi");
	my $license = &DecodeSirialKey($license_key);
	my @key_parts = split(/\t/, $license_key);
	for(my $i=0;$i<4;$i++) {
		if($key_parts[$i] =~ /^[a-zA-Z0-9]{4}$/) {
			$html =~ s/\$KEY${i}\$/$key_parts[$i]/g;
		} else {
			$html =~ s/\$KEY${i}\$//g;
		}
	}
	my $status;
	if($license > 0 && $license < 9999) {
		$status = "<font color=\"green\">o^</font><br>(${license}y[WCZXj";
	} elsif($license == 9999) {
		$status = "<font color=\"green\">o^</font><br>(CZXj";
	} else {
		$status = "<font color=\"red\">pio^j</font><br>CZX̂w<a href=\"http://www.futomi.com/library/share.html\" target=\"_blank\"></a>";
	}
	$html =~ s/\$STATUS\$/${status}/g;
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintHelp {
	my $item = $q->param('item');
	if($item =~ /[^a-zA-Z0-9\_\-]/) {
		&ErrorPrint("sȃNGXgłB");
	}
	if($item eq '') {
		&ErrorPrint("sȃNGXgłB");
	}
	my $file = "./lib/help/${item}.html";
	my $html = &ReadTemplate($file);
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintList {
	#hLg[gURLݒAzzɓ
	my %url_map;
	my @roots = split(/\t/, $CONF{'DOCUMENT_ROOT'});
	my @urls = split(/\t/, $CONF{'DOCUMENT_ROOT_URL'});
	for(my $i=0;$i<@roots;$i++) {
		$url_map{$roots[$i]} = $urls[$i];
	}
	#CfbNXf[^當ꗗ擾
	my %hash;
	tie %hash, "DB_File", "$CONF{'INDEX_DIR'}/file_no.cgi", O_RDONLY, 0644, $DB_HASH  or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/index.cgi : $!");
	my @docs;
	for my $fno (sort {$a <=> $b} keys %hash) {
		my @parts = split(/\t/, $hash{$fno});
		push(@docs, $parts[0]);
	}
	untie %hash;
	#ʂo͂
	print "Content-Type: text/html\n";
	print "\n";
	print "<html lang=\"ja\">\n";
	print "<head>\n";
	print "<meta http-equiv=\"Content-Language\" content=\"ja\">\n";
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=shift_jis\">\n";
	print "<title> </title>\n";
	print "<style type=\"text/css\">\n";
	print "  div {\n";
	print "    width:100%;\n";
	print "    font-size:12px;\n";
	print "    font-family:'Courier New','Courier','Monaco','monospace';\n";
	print "    border-style:solid;\n";
	print "    border-width:1px 0px 1px 0px;\n";
	print "    border-color:#FFFFFF #FFFFFF #CCCCCC #FFFFFF;\n";
	print "    background-color:#EEEEEE;\n";
	print "  }\n";
	print "</style>\n";
	print "</head><body>\n";
	my @roots = split(/\t/, $CONF{'DOCUMENT_ROOT'});
	my $i = 1;
	for my $path (sort @docs) {
		my $url;
		for my $root (@roots) {
			if($path =~ /^\Q${root}\E/) {
				my $tmp = $path;
				$tmp =~ s/^\Q${root}\E//;
				$url = $url_map{$root} . $tmp;
				$path =~ s/^\Q${root}\E/<font color=\"\#666666\">${root}<\/font>/;
				last;
			}
		}
		print "<div>\n";
		print "  <span style=\"width:30px;text-align:right;\"><a href=\"${url}\" target=\"_blank\">${i}</a></span>\n";
		print "  <span style=\"width:20px\"> </span>\n";
		print "  <span>${path}</span>\n";
		print "</div>\n";
		$i ++;
	}
	untie %hash;
	print "</body></html>\n";
	exit;
}

sub PrintMkindexPre {
	my $mode = $q->param('mode');
	if($mode ne '') {
		if($mode !~ /^(0|1)$/) {
			&ErrorPrint("sȒlM܂B");
		}
	}
	#ev[gǂݍ
	my $html = &ReadTemplate('./template/admin/mkindex_pre.html');
	#uwqu
	my $target = "mkindex.cgi?a=start";
	if($mode) {
		$target .= "&init=1";
		$html =~ s/\$CAPTION\$/VK\\z/g;
	} else {
		$html =~ s/\$CAPTION\$/ǉ\\z/g;
	}
	$html =~ s/\$TARGET_URL\$/${target}/g;
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintMkindexForm {
	my $mode = $q->param('mode');
	if($mode ne '') {
		if($mode !~ /^(0|1)$/) {
			&ErrorPrint("sȒlM܂B");
		}
	}
	if($mode ne '1') {
		$mode = '0';
	}
	#ev[gǂݍ
	my $html = &ReadTemplate('./template/admin/mkindex.html');
	$html =~ s/\$mode${mode}\$/checked/;
	$html =~ s/\$mode[0-9]*\$//g;
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;


}

sub PrintTestForm {
	#ev[gǂݍ
	my $html = &ReadTemplate('./template/admin/testform.html');
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub EditErrorHtml {
	#̓f[^ǂݍ
	my $html = $q->param('HTML');
	#sR[h𓝈ꂷ
	$html = &UnifyReturnCode($html);
	#t@Cɏ
	open(HTML, ">./template/error.html") or &ErrorPrint("./template/error.html ݂̏Ɏs܂B: $!");
	print HTML $html;
	close(HTML);
}

sub PrintComplete {
	my($message, $link_cap, $link_url) = @_;
	my $template = './template/admin/complete.html';
	my $html = &ReadTemplate($template);
	$html =~ s/\$MESSAGE\$/${message}/g;
	if($link_url) {
		$html =~ s/\$LINK\$/<a href=\"${link_url}\">${link_cap}<\/a>/g;
	} else {
		$html =~ s/\$LINK\$//g;
	}
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub EditResultHtml {
	#̓f[^ǂݍ
	my $html = $q->param('HTML');
	my $item = $q->param('ITEM');
	#uwq݂̑`FbN
	if($html !~ /\$LIST\$/) {
		&ErrorPrint("uS HTML ̕ҏWvł́Auwq \$LIST\$ ͕K{łB");
	}
	if($item !~ /\$DOC_TITLE\$/) {
		&ErrorPrint("uڕ̕ҏWvł́Auwq \$DOC_TITLE\$ ͕K{łB");
	}
	#sR[h𓝈ꂷ
	$html = &UnifyReturnCode($html);
	$item = &UnifyReturnCode($item);
	#t@Cɏ
	open(HTML, ">./template/result.html") or &ErrorPrint("./template/result.html ݂̏Ɏs܂B: $!");
	print HTML $html;
	close(HTML);
	open(ITEM, ">./template/item.html") or &ErrorPrint("./template/item.html ݂̏Ɏs܂B: $!");
	print ITEM $item;
	close(ITEM);
}

sub PrintEditResultForm {
	#ev[gǂݍ
	my $html = &ReadTemplate('./template/admin/edit_result.html');
	my $result = &ReadTextFile('./template/result.html');
	my $item = &ReadTextFile('./template/item.html');
	#u
	$result = &SecureHtml($result);
	$item = &SecureHtml($item);
	$html =~ s/\$HTML\$/${result}/;
	$html =~ s/\$ITEM\$/${item}/;
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintSampleForm {
	#IvVǂݍ
	my $sort = $q->param('sort');
	my $num = $q->param('num');
	my $charset = $q->param('charset');
	#IvV̒l`FbN
	if($sort ne '' && $sort !~ /^(1|2|3)$/) {
		&ErrorPrint("sȒlM܂B");
	}
	if($num =~ /[^0-9]/) {
		&ErrorPrint("sȒlM܂B");
	}
	if($charset ne '' && $charset !~ /^(sjis|euc|utf8)$/i) {
		&ErrorPrint("sȒlM܂B");
	}
	#ev[gǂݍ
	my $template = './template/admin/mkform.html';
	my $html = &ReadTemplate($template);
	#TvtH[𐶐
	my $sample = &MakeSearchForm($sort, $num, $charset);
	#u
	$html =~ s/\$SAMPLE_FORM\$/${sample}/;
	$html =~ s/\$sort${sort}\$/selected/;
	$html =~ s/\$sort[0-9]*\$//g;
	$html =~ s/\$num${num}\$/selected/;
	$html =~ s/\$num[0-9]*\$//g;
	$html =~ s/\$charset_${charset}\$/selected/;
	$html =~ s/\$charset_[a-zA-Z0-9]*\$//g;
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub MakeSearchForm {
	my($sort, $num, $charset) = @_;
	my $sample;
	$sample .= "<form action=\"$CONF{'BASE_URL'}/search.cgi\" method=\"get\">\n";
	if($charset =~ /^(sjis|euc|utf8)$/i) {
		$sample .= "  <input type=\"hidden\" name=\"charset\" value=\"$1\">\n";
	}
	if($num =~ /[0-9]+/ && $num > 0) {
		$sample .= "  <input type=\"hidden\" name=\"num\" value=\"${num}\">\n";
	}
	if($sort =~ /^(1|2|3)$/) {
		$sample .= "  <input type=\"hidden\" name=\"sort\" value=\"${sort}\">\n";
	}
	$sample .= "  <input type=\"text\" name=\"q\" maxlength=\"256\">\n";
	$sample .= "  <input type=\"submit\" name=\"s\" value=\"Search!\">\n";
	$sample .= "</form>\n";
	return $sample;
}

sub LogOff {
	my($sid) = @_;
	my $session = new FCC::Apache::Session("./session");
	$session->logoff($sid);
	my $message = 'OIt܂B';
	my $link_cap = 'OIʂ';
	my $template = './template/admin/complete.html';
	my $html = &ReadTemplate($template);
	$html =~ s/\$MESSAGE\$/${message}/g;
	$html =~ s/\$LINK\$/<a href=\"${CGI_URL}\">${link_cap}<\/a>/g;
	my $content_length = length($html);
	print &ClearCookie($COOKIE_NAME);
	print "Content-Length: $content_length\n";
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "\n";
	print $html;
	exit;
}

sub PrintLogonForm {
	#ev[gǂݍ
	my $template = './template/admin/logon.html';
	my $html = &ReadTemplate($template);
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub SessionAuth {
	my($sid, $session_data_ref) = @_;
	my $session = new FCC::Apache::Session("./session");
	%{$session_data_ref} = $session->sessoin_auth($sid);
	unless($session_data_ref->{_sid}) {
		my $err = "F؂Ɏs܂B<br>\n" . $session->error();
		print &ClearCookie($COOKIE_NAME);
		print "Content-Type: text/plain\n";
		print "\n";
		print "$err";
		exit;
	}
	return $session;
}

sub LogOn {
	my $in_id = $q->param('id');
	my $in_pass = $q->param('pass');
	if($in_id eq '') {
		&ErrorPrint("ǗID͂ĉB");
	}
	if($in_pass eq '') {
		&ErrorPrint("pX[h͂ĉB");
	}
	if($CONF{'ADMIN_ID'} ne $in_id) {
		&ErrorPrint("F؃G[");
	}
	my $in_pass_digest = Digest::Perl::MD5::md5_hex($in_pass);
	if($in_pass_digest ne $CONF{'PASS'}) {
		&ErrorPrint("F؃G[");
	}
	my $session = new FCC::Apache::Session("./session");
	unless($session) {
		&ErrorPrint("VXeG[");
	}
	my %session_data = ${session}->session_create($in_id);
	unless($session_data{_sid}) {
		my $err = "F؂Ɏs܂B<br>\n" . $session->error();
		&PrintError("$err");
	}
	my $target_url = $CGI_URL . "?t=" . time;
	print &SetCookie($COOKIE_NAME, $session_data{_sid});
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "\n";
	print "<html>\n";
	print "<head>\n";
	print "<meta http-equiv=\"content-type\" content=\"text/html;charset=shift_jis\">\n";
	print "<meta http-equiv=\"Set-Cookie\" content=\"${COOKIE_NAME}=$session_data{_sid};\">\n";
	print "<meta http-equiv=\"refresh\" content=\"0;URL=${target_url}\">\n";
	print "<title>OI...</title>\n";
	print "</head>\n";
	print "<body>\n";
	print "<p>OI ...</p>\n";
	print "</body></html>\n";
	exit;
}

sub PrintPasswdSetForm {
	#ev[gǂݍ
	my $template = './template/admin/passwd_new.html';
	my $html = &ReadTemplate($template);
	#ʂo͂
	my $content_length = length($html);
	print "Content-Length: $content_length\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintPasswdChangeComplete {
	my $html = &ReadTemplate('./template/admin/complete.html');
	my $message = 'ǗID^pX[hύX܂BłɃOIt܂̂ŁAVID^pX[hŃOIĉB';
	$html =~ s/\$MESSAGE\$/${message}/;
	$html =~ s/\$LINK\$/<a href=\"${CGI_URL}\" target=\"_top\">OI<\/a>/;
	my $content_length = length $html;
	print &ClearCookie($COOKIE_NAME);
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PasswdChange {
	my $admin_id = $q->param('ADMIN_ID');
	my $pass1 = $q->param('PASS1');
	my $pass2 = $q->param('PASS2');
	if($admin_id eq '') {
		&ErrorPrint("ǗID͂ĉB");
	} else {
		if($admin_id =~ /[^0-9a-zA-Z\-\_]/) {
			&ErrorPrint("ǗIDɎwł镶͔ppAnCtAA_[XRAłB");
		}
	}
	if($pass1 eq '' || $pass2 eq '') {
		&ErrorPrint("pX[h͂ĉB");
	}
	if($pass1 =~ /[^0-9a-zA-Z\-\_]/) {
		&ErrorPrint("pX[hɎwł镶͔ppAnCtAA_[XRAłB");
	}
	if($pass1 ne $pass2) {
		&ErrorPrint("pX[hႢ܂B");
	}
	$CONF{'ADMIN_ID'} = $admin_id;
	$CONF{'PASS'} = Digest::Perl::MD5::md5_hex($pass1);
	&WriteConf('./conf/config.cgi', \%CONF);
}

sub PrintPasswdForm {
	my $html = &ReadTemplate('./template/admin/passwd_change.html');
	$html =~ s/\$ADMIN_ID\$/$CONF{'ADMIN_ID'}/;
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintEditErrorForm {
	my $in = &ReadTextFile('./template/error.html');
	my $out = &ReadTemplate('./template/admin/edit_error.html');
	$in = &SecureHtml($in);
	$out =~ s/\$HTML\$/$in/;
	my $content_length = length $out;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $out;
	exit;
}

sub PrintSetConfComplete {
	my($rebuild_flag) = @_;
	my $html = &ReadTemplate("./template/admin/conf_complete.html");
	if($rebuild_flag) {
		my $message = 'ݒ𔽉f邽߂ɁACfbNX̍č\zsKv܂BuCfbNXč\zv{^āACfbNXč\zĉB';
		my $form;
		$form .= "<form action=\"${CGI_URL}\" method=\"post\">\n";
		$form .= "<input type=\"hidden\" name=\"a\" value=\"mkindex_form\">\n";
		$form .= "<input type=\"hidden\" name=\"mode\" value=\"1\">\n";
		$form .= "<input type=\"submit\" name=\"b1\" value=\"CfbNXč\\z\">\n";
		$form .= "</form>\n";
		$html =~ s/\$MESSAGE\$/${message}/;
		$html =~ s/\$FORM\$/${form}/;
	} else {
		$html =~ s/\$MESSAGE\$//;
		$html =~ s/\$FORM\$//;
	}
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub WriteConf {
	my($file, $data_ref) = @_;
	open(FILE, ">${file}") or &ErrorPrint("ݒt@C݂̏Ɏs܂B: $!");
	while( my($key, $value) = each %{$data_ref} ) {
		print FILE "${key}\t${value}\n";
	}
	close(FILE);
}

sub SetConf {
	#͒l擾B
	my %in;
	$in{'BASE_URL'} = $q->param('BASE_URL');
	$in{'DOCUMENT_ROOT'} = $q->param('DOCUMENT_ROOT');
	$in{'DOCUMENT_ROOT_URL'} = $q->param('DOCUMENT_ROOT_URL');
	$in{'EXCLUDE_DIR'} = $q->param('EXCLUDE_DIR');
	$in{'INDEX_DIR'} = $q->param('INDEX_DIR');
	$in{'EXT'} = $q->param('EXT');
	$in{'READ_DOC_SIZE'} = $q->param('READ_DOC_SIZE');
	$in{'ZEN_HAN_FLAG'} = $q->param('ZEN_HAN_FLAG');
	$in{'CAPS_FLAG'} = $q->param('CAPS_FLAG');
	$in{'SPRIT_WORD_FLAG'} = $q->param('SPRIT_WORD_FLAG');
	$in{'TITLE_START_TAG'} = $q->param('TITLE_START_TAG');
	$in{'TITLE_END_TAG'} = $q->param('TITLE_END_TAG');
	$in{'TITLE_WEIGHT_MAGNIFICATION'} = $q->param('TITLE_WEIGHT_MAGNIFICATION');
	$in{'DISP_NUM'} = $q->param('DISP_NUM');
	$in{'STOP_WORDS'} = $q->param('STOP_WORDS');
	$in{'DISP_CONTENTS_FLAG'} = $q->param('DISP_CONTENTS_FLAG');
	$in{'DISP_CONTENTS_SIZE'} = $q->param('DISP_CONTENTS_SIZE');
	$in{'KEYWORD_COLOR'} = $q->param('KEYWORD_COLOR');
	$in{'TIMEZONE_OFFSET'} = $q->param('TIMEZONE_OFFSET');
	#ꂼ̓͒l`FbN
	#̃VXefBNg URL
	if($in{'BASE_URL'} eq '') {
		&ErrorPrint("ũVXefBNg URLv͂ĉB");
	} else {
		unless(&UrlCheck($in{'BASE_URL'})) {
			&ErrorPrint("ũVXefBNg URLvsK؂łBhttp:// LqĉB");
		}
		$in{'BASE_URL'} =~ s/\/$//;
	}
	#i[fBNgihLg[gj
	if($in{'DOCUMENT_ROOT'} eq '') {
		&ErrorPrint("ui[fBNgihLg[gjv͂ĉB");
	} else {
		$in{'DOCUMENT_ROOT'} = &UnifyReturnCode($in{'DOCUMENT_ROOT'});
		my @parts = split(/\n/, $in{'DOCUMENT_ROOT'});
		my @new_parts;
		for my $v (@parts) {
			$v =~ s/^\s+//;
			$v =~ s/\s+$//;
			if($v ne '') {
				if($v =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
					&ErrorPrint("ui[fBNgihLg[gjvɕsK؂ȕ܂܂Ă܂B");
				}
				$v =~ s/\/$//;
				unless(-d "$v") {
					&ErrorPrint("ui[fBNgihLg[gjvɎw肵 $v ݂ȂAfBNgł͂܂B");
				}
				push(@new_parts, $v);
			}
		}
		unless(scalar @new_parts) {
			&ErrorPrint("ui[fBNgihLg[gjvw肵ĉB");
		}
		$in{'DOCUMENT_ROOT'} = join("\t", @new_parts);
	}
	#i[fBNg URL
	if($in{'DOCUMENT_ROOT_URL'} eq '') {
		&ErrorPrint("ui[fBNg URLv͂ĉB");
	} else {
		$in{'DOCUMENT_ROOT_URL'} = &UnifyReturnCode($in{'DOCUMENT_ROOT_URL'});
		my @parts = split(/\n/, $in{'DOCUMENT_ROOT_URL'});
		my @new_parts;
		for my $v (@parts) {
			$v =~ s/\s//g;
			if($v ne '') {
				if($v =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t]/) {
					&ErrorPrint("ui[fBNg URLvɕsK؂ȕ܂܂Ă܂B");
				}
				$v =~ s/\/$//;
				push(@new_parts, $v);
			}
		}
		unless(scalar @new_parts) {
			&ErrorPrint("ui[fBNg URLvw肵ĉB");
		}
		$in{'DOCUMENT_ROOT_URL'} = join("\t", @new_parts);
	}
	#CfbNXOfBNg̎w
	if($in{'EXCLUDE_DIR'} ne '') {
		$in{'EXCLUDE_DIR'} = &UnifyReturnCode($in{'EXCLUDE_DIR'});
		my @parts = split(/\n/, $in{'EXCLUDE_DIR'});
		my @new_parts;
		for my $v (@parts) {
			$v =~ s/^\s+//;
			$v =~ s/\s+$//;
			if($v ne '') {
				if($v =~ /[^a-zA-Z0-9\/\:\-\_\.\@\+\t\s]/) {
					&ErrorPrint("uCfbNXOfBNgvɕsK؂ȕ܂܂Ă܂B");
				}
				$v =~ s/\/$//;
				unless(-d "$v") {
					&ErrorPrint("uCfbNXOfBNgvɎw肵 $v ݂ȂAfBNgł͂܂B");
				}
				push(@new_parts, $v);
			}
		}
		if(scalar @new_parts) {
			$in{'EXCLUDE_DIR'} = join("\t", @new_parts);
		} else {
			$in{'EXCLUDE_DIR'} = '';
		}
	}
	#CfbNXi[fBNg
	if($in{'INDEX_DIR'} eq '') {
		&ErrorPrint("uCfbNXi[fBNgv͂ĉB");
	} else {
		if($in{'INDEX_DIR'} =~ /[^a-zA-Z0-9\/\-\_\.\@\+\t]/) {
			&ErrorPrint("uCfbNXi[fBNgvɕsK؂ȕ܂܂Ă܂B");
		}
		$in{'INDEX_DIR'} =~ s/\/$//;
		unless(-d $in{'INDEX_DIR'}) {
			&ErrorPrint("uCfbNXi[fBNgvŎw肵fBNg $in{'INDEX_DIR'} ݂͑ȂA̓fBNgł͂܂BOɃfBNg쐬Ăݒ肵ĉB");
		}
		if( open(TEST, ">$in{'INDEX_DIR'}/test.cgi") ) {
			close(TEST);
		} else {
			&ErrorPrint("uCfbNXi[fBNgvŎw肵fBNgɃt@C𐶐邱Ƃł܂łBp[~bVmFĉB");
		}
	}
	#Ώۃt@C̊gq
	if($in{'EXT'} eq '') {
		&ErrorPrint("uΏۃt@C̊gqv͂ĉB");
	} else {
		$in{'EXT'} = &UnifyReturnCode($in{'EXT'});
		my @parts = split(/\n/, $in{'EXT'});
		my @new_parts;
		for my $v (@parts) {
			$v =~ s/\s//g;
			if($v ne '') {
				if($v =~ /[^a-zA-Z\.\_\-]/) {
					&ErrorPrint("uΏۃt@C̊gqvɕsK؂ȕ܂܂Ă܂B");
				}
				push(@new_parts, $v);
			}
		}
		unless(scalar @new_parts) {
			&ErrorPrint("uΏۃt@C̊gqvw肵ĉB");
		}
		$in{'EXT'} = join("\t", @new_parts);
	}
	#CfbNXΏۃt@C̓ǍTCY
	if($in{'READ_DOC_SIZE'} ne '') {
		if($in{'READ_DOC_SIZE'} =~ /[^0-9]/) {
			&ErrorPrint("uCfbNXΏۃt@C̓ǍTCYv͔pŎw肵ĉB");
		} elsif($in{'READ_DOC_SIZE'} eq '0') {
			$in{'READ_DOC_SIZE'} = '';
		}
	}
	#L[[h̉p̔pESp̋
	if($in{'ZEN_HAN_FLAG'} eq '') {
		&ErrorPrint("uL[[h̉p̔pESp̋ʁvIĉB");
	} else {
		unless($in{'ZEN_HAN_FLAG'} eq '0' || $in{'ZEN_HAN_FLAG'} eq '1') {
			&ErrorPrint("uL[[h̉p̔pESp̋ʁvɕsȒlM܂B");
		}
	}
	#L[[h̃At@xbg̑啶E̋
	if($in{'CAPS_FLAG'} eq '') {
		&ErrorPrint("uL[[h̃At@xbg̑啶E̋ʁvIĉB");
	} else {
		unless($in{'CAPS_FLAG'} eq '0' || $in{'CAPS_FLAG'} eq '1') {
			&ErrorPrint("uL[[h̃At@xbg̑啶E̋ʁvɕsȒlM܂B");
		}
	}
	#p̋؂
	if($in{'SPRIT_WORD_FLAG'} eq '') {
		&ErrorPrint("up̋؂vIĉB");
	} else {
		unless($in{'SPRIT_WORD_FLAG'} eq '0' || $in{'SPRIT_WORD_FLAG'} eq '1') {
			&ErrorPrint("up̋؂vɕsȒlM܂B");
		}
	}
	#^CgƂ݂Ȃ^O
	if($in{'TITLE_START_TAG'} eq '') {
		&ErrorPrint("u^CgƂ݂Ȃ^OiJnjv͂ĉB");
	}
	if($in{'TITLE_END_TAG'} eq '') {
		&ErrorPrint("u^CgƂ݂Ȃ^OiIjv͂ĉB");
	}
	#^CgɊ܂܂錏gL[[h̏dݕt{
	if($in{'TITLE_WEIGHT_MAGNIFICATION'} eq '') {
		&ErrorPrint("u^CgɊ܂܂錏gL[[h̏dݕt{v͂ĉB");
	} else {
		if($in{'TITLE_WEIGHT_MAGNIFICATION'} =~ /[^0-9]/) {
			&ErrorPrint("u^CgɊ܂܂錏gL[[h̏dݕt{vɂ͔pŎw肵ĉB");
		}
	}
	#ʕ\̃ftHgl
	if($in{'DISP_NUM'} eq '') {
		&ErrorPrint("uʕ\̃ftHglv͂ĉB");
	} else {
		if($in{'DISP_NUM'} =~ /[^0-9]/) {
			&ErrorPrint("uʕ\̃ftHglvɂ͔pŎw肵ĉB");
		}
		unless($in{'DISP_NUM'} > 0) {
			&ErrorPrint("uʕ\̃ftHglvɂ1ȏ̐w肵ĉB");
		}
	}
	#Xgbv[h
	if($in{'STOP_WORDS'} ne '') {
		$in{'STOP_WORDS'} = &UnifyReturnCode($in{'STOP_WORDS'});
		my @parts = split(/\n/, $in{'STOP_WORDS'});
		my @new_parts;
		for my $v (@parts) {
			$v =~ s/\s//g;
			if($v ne '') {
				push(@new_parts, $v);
			}
		}
		$in{'STOP_WORDS'} = join("\t", @new_parts);
	}
	#̕\
	if($in{'DISP_CONTENTS_FLAG'} eq '') {
		&ErrorPrint("u̕\vIĉB");
	} else {
		unless($in{'DISP_CONTENTS_FLAG'} eq '0' || $in{'DISP_CONTENTS_FLAG'} eq '1') {
			&ErrorPrint("u̕\vɕsȒlM܂B");
		}
	}
	if($in{'DISP_CONTENTS_FLAG'} eq '1' && $in{'DISP_CONTENTS_SIZE'} eq '') {
		&ErrorPrint("u̕\v́u\TCYvw肵ĉB");
	}
	if($in{'DISP_CONTENTS_SIZE'} ne '') {
		if($in{'DISP_CONTENTS_SIZE'} =~ /[^0-9]/) {
			&ErrorPrint("u̕\v́u\TCYvɂ͔pŎw肵ĉB");
		}
	}
	#L[[h̕\F
	if($in{'KEYWORD_COLOR'} ne '') {
		if($in{'KEYWORD_COLOR'} !~ /^\#[0-9A-Fa-f]{6}$/) {
			&ErrorPrint("uL[[h̕\Fv́A16iŕ\LĉBiwF#FF0000j")
		}
	}
	#^C][ItZbg
	if($in{'TIMEZONE_OFFSET'} eq '') {
		&ErrorPrint("^C][ItZbgw肵ĉB");
	} else {
		if($in{'TIMEZONE_OFFSET'} =~ /^(\+|\-){0,1}([0-9]{1,2})$/) {
			my $sign = $1;
			my $offset = $2;
			if($sign eq '+') {
				$in{'TIMEZONE_OFFSET'} = $2;
			}
			if($offset > 12) {
				&ErrorPrint("^C][ItZbg̎w肪ԈĂ܂B");
			}
		} else {
			&ErrorPrint("^C][ItZbg̎w肪ԈĂ܂B");
		}
	}


	#ݒ̘AzzuBāACfbNXč\zKvȍڂ̕ύXȂ`FbNXB
	my $index_rebuild_flag = 0;
	while( my($key, $value) = each %in) {
		if($key =~ /^(DOCUMENT_ROOT|EXCLUDE_DIR|INDEX_DIR|EXT|READ_DOC_SIZE|ZEN_HAN_FLAG|CAPS_FLAG|SPRIT_WORD_FLAG|TITLE_START_TAG|TITLE_END_TAG)$/) {
			if($CONF{$key} ne $in{$key}) {
				$index_rebuild_flag = 1;
			}
		}
		$CONF{$key} = $in{$key};
	}
	#ݒ
	&WriteConf('./conf/config.cgi', \%CONF);
	#߂l
	return $index_rebuild_flag;
}

sub PrintConfForm {
	my $html = &ReadTemplate("./template/admin/conf.html");
	if($CONF{'BASE_URL'} eq '') {
		my $url = &GetRequestedUrl;
		$url =~ s/\/${CGI_URL}\?.*//;
		$CONF{'BASE_URL'} = $url;
	}
	if($CONF{'DOCUMENT_ROOT'} eq '') {
		my $root = &GetDocumentRoot;
		$CONF{'DOCUMENT_ROOT'} = $root;
	}
	if($CONF{'DOCUMENT_ROOT_URL'} eq '') {
		my $url = &GetDocumentRootUrl;
		$CONF{'DOCUMENT_ROOT_URL'} = $url;
	}
	while( my($key, $value) = each %CONF) {
		$value = &SecureHtml($value);
		if($key =~ /^(ZEN_HAN_FLAG|CAPS_FLAG|SPRIT_WORD_FLAG|DISP_CONTENTS_FLAG)$/) {
			$html =~ s/\$${key}$CONF{$key}\$/checked/;
			$html =~ s/\$${key}[0-9]*\$//g;
		} else {
			if($key =~ /^(DOCUMENT_ROOT|DOCUMENT_ROOT_URL|EXCLUDE_DIR|STOP_WORDS|EXT)$/) {
				$value =~ s/\t/\n/g;
			}
			$html =~ s/\$${key}\$/${value}/g;
		}
	}
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub GetDocumentRootUrl {
	my $url = "$ENV{'HTTP_HOST'}";
	my $protocol = 'http://';
	if($ENV{'HTTPS'} =~ /on/i) {
		$protocol = 'https://';
	}
	my $url = "${protocol}${url}";
	if($ENV{'SCRIPT_NAME'} =~ /^\/\~([^\/]+)/) {
		$url .= "/$1";
	} elsif($ENV{'REQUEST_URI'} =~ /^\/\~([^\/]+)/) {
		$url .= "/$1";
	}
	return "${url}";
}

sub GetDocumentRoot {
	my $root = $ENV{'DOCUMENT_ROOT'};
	if($ENV{'SCRIPT_NAME'} =~ /^\/\~([^\/]+)/ || $ENV{'REQUEST_URI'} =~ /^\/\~([^\/]+)/) {
		my $acnt =  $1;
		if($ENV{'SCRIPT_FILENAME'} =~ /^(.+?\Q${acnt}\E(\/public_html)*)/) {
			$root = $1;
		} else {
			$root .= "/$1";
		}
	}
	return $root;
}

sub GetRequestedUrl {
	my $url = "$ENV{'HTTP_HOST'}$ENV{'REQUEST_URI'}";
	my $protocol = 'http://';
	if($ENV{'HTTPS'} =~ /on/i) {
		$protocol = 'https://';
	}
	my $url = "${protocol}${url}";
	if($ENV{'SCRIPT_NAME'} =~ /^\/\~([^\/]+)/) {
		$url .= "/$1";
	} elsif($ENV{'REQUEST_URI'} =~ /^\/\~([^\/]+)/) {
		$url .= "/$1";
	}
	return "${url}";
}

sub PrintTopFrame {
	my $html = &ReadTemplate("./template/admin/top.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintMenuFrame {
	my $html = &ReadTemplate("./template/admin/menu.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub PrintParentFrame {
	my $html = &ReadTemplate("./template/admin/parent.html");
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub GetConf {
	my($file) = @_;
	my %data;
	open(FILE, "$file") || &ErrorPrint("ݒt@C $file I[vł܂łB: $!");
	while(<FILE>) {
		if(/^([^\t]+)\t(.*)/) {
			$data{$1} = $2;
		}
	}
	close(FILE);
	return %data;
}


sub UnifyReturnCode {
	my($String) = @_;
	$String =~ s/\x0D\x0A/\n/g;
	$String =~ s/\x0D/\n/g;
	$String =~ s/\x0A/\n/g;
	return $String;
}

sub GetCookie {
    #Cookie=CookielzɊi[B
    my @pairs = split(/\;\s*/, $ENV{'HTTP_COOKIE'});
    #Cookiei[Azz%cookies`B
    my %cookies;
    for my $pair (@pairs) {
        #Cookie=Cookiel = ŕāAXJ[ϐɊi[B
        my($name, $value) = split(/=/, $pair);
        #CookielURLfR[hB
        $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
        $value =~ s/\+/ /g;
        #Azz%cookiesɊi[B
        $cookies{$name} = $value;
    }
    #Cookiei[Azz%cookiesԂB
    return %cookies;
}

sub SetCookie {
    my($name, $value, $expire, $domain, $path) = @_;
    #Cookie̒lURLGR[hB
    $value =~ s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
    $value =~ tr/ /+/;
    #Cookiewb_[`B
    #ł́ACookieCookielZbgB
    my $header .= "Set-Cookie: $name=$value\;";
    #L̎w肪΁AexpireCookiewb_[ɒǉB
    if($expire) {
        #LƂȂGMTŎ擾B
        my($sec, $min, $hour, $day, $mon, $year, $weekday) = 
          gmtime(time + $expire*60*60*24);
        #N𐼗ɂB
        $year += 1900;
        #bAAԁA10菬l̏ꍇA擪0B
        $sec = sprintf("%02d", $sec);
        $min = sprintf("%02d", $min);
        $hour = sprintf("%02d", $hour);
        $day = sprintf("%02d", $day);
        #zɒ`B
        my @month_list = ('Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun',
                    'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec');
        #jzɒ`B
        my @week_list = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
        #L𐶐B
        #j͗jɁA͌ɕϊB
        my $date = "$week_list[$weekday], $day-$month_list[$mon]-$year $hour:$min:$sec GMT";
        #Cookiewb_[ɗLǉB
         $header .= " expires=$date;";
    }
    #hC̎w肪΁AdomainCookiewb_[ɒǉB
    if($domain) {
        $header .= " domain=$domain;";
    }
    #pX̎w肪΁ApathCookiewb_[ɒǉB
    if($path) {
        $header .= " path=$path;";
    }
    #Set-Cookiewb_[̍ŌɉsB
    $header .= "\n";
    #Set-Cookiewb_[ԂB
    return $header;
}

sub ClearCookie {
    my($name) = @_;
    #CookieL 1970/1/1 00:00:00 ɃZbgB
    my $expire = 'Thu, 01-Jan-1970 00:00:00 GMT';
    #Set-Cookiewb_[𐶐B
    #Cookiel͉łǂ̂ŁAł clear ƂB
    my $cookie_header = "Set-Cookie: $name=clear; expires=$expire;";
    #Set-Cookiewb_[̍ŌɉsB
    $cookie_header .= "\n";
    #Set-Cookiewb_[ԂB
    return $cookie_header;
}

sub SecureHtml {
	my($html) = @_;
	$html =~ s/\&amp;/\&/g;
	$html =~ s/\&/&amp;/g;
	$html =~ s/\"/&quot;/g;
	$html =~ s/</&lt;/g;
	$html =~ s/>/&gt;/g;
	return $html;
}

sub UrlCheck {
	my($url) = @_;
	unless($url =~ /^https*:\/\/[^\/]+/) {
		return;
	}
	if($url =~ /[^0-9a-zA-Z\:\/\.\-\_\#\%\&\=\~\+\?]/) {
		return;
	}
	return 1;
}

sub ReadTextFile {
	my($file) = @_;
	my $size = -s $file;
	if(!open(IN, "$file")) {
		&ErrorPrint2("$file I[vł܂łB : $!");
	}
	binmode(IN);
	my $string;
	sysread(IN, $string, $size);
	close(IN);
	$string = &UnifyReturnCode($string);
	return $string;
}

sub ReadTemplate {
	my($template) = @_;
	my $size = -s $template;
	if(!open(IN, "$template")) {
		&ErrorPrint2("ev[gt@C $template I[vł܂łB : $!");
	}
	binmode(IN);
	my $filestr;
	sysread(IN, $filestr, $size);
	close(IN);
	$filestr = &UnifyReturnCode($filestr);
	$filestr = &CopyRight($filestr);
	$filestr =~ s/\$CGI_URL\$/${CGI_URL}/g;
	return $filestr;
}

sub CopyRight {
	my($str) = @_;
	$str =~ s/\$COPYRIGHT\$/${COPYRIGHT}/g;
	$str =~ s/\$COPYRIGHT1\$/${COPYRIGHT1}/g;
	$str =~ s/\$COPYRIGHT2\$/${COPYRIGHT2}/g;
	$str =~ s/\$TITLE\$/${COPYRIGHT}/g;
	return $str;
}

sub DecodeSirialKey {
	my($sirial) = @_;
	if($sirial eq '') {return;}
	if($sirial =~ /[^0-9a-zA-Z\-\t\s]/) {
		return;
	}
	my @parts = split(/[\-\t\s]/, $sirial);
	my $sirial;
	for my $part (@parts) {
		if($part eq '') {return;}
		$part = unpack("n", pack("H4", $part));
		$part = sqrt($part);
		if($part % 1) {
			return;
		}
		$part = sprintf("%02lx", $part);
		$sirial .= $part;
	}
	$sirial = hex $sirial;
	my $license = ($sirial - 12345) / 98765;
	if($license <= 0) {return;}
	my $int_value = int $license;
	if( $license - $int_value != 0 ) {return;}
	return $license;
}

sub MakeSirialKey {
	my($num) = @_;
	my $num_tmp = $num * 98765 + 12345;
	my $sirial_tmp = unpack("H*", pack("N", $num_tmp));
	my @sirial_list;
	for(my $i=0;$i<4;$i++) {
		my $key = substr($sirial_tmp, $i*2, 2);
		$key = hex $key;
		$key = $key * $key;
		$key = unpack("H*", pack("n", $key));
		$sirial_list[$i] = $key;
	}
	my $sirial = join(" ", @sirial_list);
	return $sirial;
}

sub ErrorPrint {
	my($message) = @_;
	my $html = &ReadTemplate("./template/admin/error.html");
	$html =~ s/\$error\$/$message/ig;
	$html = &CopyRight($html);
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub ErrorPrint2 {
	my($message) = @_;
	print "Content-Type: text/plain; charset=Shift_JIS\n";
	print "\n";
	print $message;
	exit;
}

sub GetThisFileName {
	my $string;
	if($ENV{'SCRIPT_NAME'}) {
		$string = $ENV{'SCRIPT_NAME'};
	} elsif($ENV{'REQUEST_URI'}) {
		$string = $ENV{'REQUEST_URI'};
	} else {
		return 'admin.cgi';
	}
	my($part) = split(/\?/, $string);
	my @parts = split(/\//, $part);
	my $script_name = pop @parts;
	return $script_name;
}
