#!/usr/bin/perl
######################################################################
# SCGI Ver 1.0.0
# iCfbNXpXNvgj
# Copyright(C) futomi 2005
# http://www.futomi.com/
######################################################################
use strict;
BEGIN {
	use FindBin qw($Bin);
	chdir $FindBin::Bin;
	use lib "$FindBin::Bin/lib";
	use CGI;
	use CGI::Carp qw(fatalsToBrowser);
	use Jcode;
	use Text::ParseWords;
	unless (eval "use Fcntl; 1") {
		print "Content-Type: text/plain\n\n";
		print "FcntlW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
	unless (eval "use DB_File; 1") {
		print "Content-Type: text/plain\n\n";
		print "DB_FileW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
}
$| = 1;
my $q = new CGI;
my $VERSION = '1.0.0';
#Copyright
my $COPYRIGHT = "futomi's CGI Cafe - SCGI $VERSION";
my $COPYRIGHT1 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">futomi\'s CGI Cafe</a>";
my $COPYRIGHT2 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">${COPYRIGHT}</a>";

#NGXg\bh𔻒
if($ENV{'REQUEST_METHOD'} ne 'GET') {
	&ErrorPrint("sȃANZXłB");
}

#CGIt@C̃t@C擾
my $CGI_URL = &GetThisFileName;

#ݒf[^擾
my %CONF = &GetConf('./conf/config.cgi');

#L[[h擾
my $keyword = $q->param('q');

#R[ḧ擾
my $charset = $q->param('charset');
if($charset ne '' && $charset =~ /^(sjis|euc|utf8)$/) {
	$charset = '';
}
#L[[hShift_JISɕϊ
unless($charset eq 'sjis') {
	if($charset =~ /^(euc|utf8)$/) {
		&Jcode::convert(\$keyword, 'sjis', "${charset}");
	} else {
		&Jcode::convert(\$keyword, 'sjis');
	}
}
#L[[ht[YƂɕ
my @keyword_list_tmp = &ParseKeyword($keyword);

#eL[[h̃t[Yɕt^ꂽRg[LL^A
#t[YRg[폜B
my(%controls, $pre_word, @keyword_list);
for(my $i=0;$i<@keyword_list_tmp;$i++) {
	my $value = $keyword_list_tmp[$i];
	if($value =~ /^(AND|OR|\|)$/i) {
		next;
	} else {
		if($value =~ /^(\-)(.+)/) {
			my $control = $1;
			$value = $2;
			$controls{$value} = $control;
		} elsif($i > 0 && $keyword_list_tmp[$i - 1] =~ /^(AND)$/i) {
			$controls{$value} = $1;
		} elsif($i > 0 && $keyword_list_tmp[$i - 1] =~ /^(OR|\|)$/i) {
			$controls{$value} = $1;
		} elsif($value =~ /^\+(.+)/) {
			$value = $1;
		}
		if($value =~ /^\"(.+?)\"$/) {
			$value = $1;
		}
		push(@keyword_list, $value);
	}
}

my %doc_list_bin;
my %index_hash;
tie %index_hash, "DB_File", "$CONF{'INDEX_DIR'}/index.cgi", O_RDONLY, 0644, $DB_HASH  or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/index.cgi : $!");
my %positions;
tie %positions, "DB_File", "$CONF{'INDEX_DIR'}/pos.cgi", O_RDONLY, 0644, $DB_HASH or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/pos.cgi : $!");
my %hit_pos;
for my $word (@keyword_list) {
	my @word_chars;
	#L[[hꕶ
	if($CONF{'SPRIT_WORD_FLAG'} == 1) {
		@word_chars = &SpritSjisWords(\$word);
	} else {
		@word_chars = &SpritSjisChars(\$word);
	}
	#CfbNXt@CYׂ̕Ă܂ޕ
	my $list_bin;
	for my $char (@word_chars) {
		if(exists $index_hash{$char}) {
			if($list_bin eq '') {
				$list_bin = $index_hash{$char};
			} else {
				$list_bin = $list_bin & $index_hash{$char};
			}
		}
	}
	my @doc_list = &ConvBin2List($list_bin);
	#L[[h܂ޕ
	my %hit_docs;
	for my $fno (@doc_list) {
		my $hit_flag = 1;
		my @positions = &SearchKeywordFromDoc($fno, $word, \%positions);
		if(@positions) {
			$hit_pos{$fno}->{$word} = [@positions];
		} else {
			$hit_flag = 0;
		}
		if($hit_flag) {
			#t@Cԍ\CfbNX𐶐it@Cԍ̈ʒu1łȊO0j
			my $file_no_bin;
			my $chunk_pos = int( $fno / 32 );
			my $all_zero_chunk = pack("N", 0);
			for(my $i=0;$i<=$chunk_pos;$i++) {
				if($i == $chunk_pos) {
					my $amari = $fno % 32;
					#my $chunk = 0b10000000000000000000000000000000 >> $amari;
					my $chunk = unpack("N", pack("B32", '10000000000000000000000000000000')) >> $amari;
					$file_no_bin .= pack("N", $chunk)
				} else {
					$file_no_bin .= $all_zero_chunk;
				}
			}
			$doc_list_bin{$word} = $doc_list_bin{$word} | $file_no_bin;
		}
	}
}
untie %index_hash;
untie %positions;

#Rg[LlāAL[[h܂ރhLg
my $hit_doc_list_bin;
for my $word (@keyword_list) {
	if($hit_doc_list_bin eq '') {
		$hit_doc_list_bin = $doc_list_bin{$word};
	} elsif($controls{$word} eq '-') {
		#܂܂Ȃ
		$hit_doc_list_bin = ($hit_doc_list_bin ^ $doc_list_bin{$word}) & $hit_doc_list_bin;
	} elsif($controls{$word} =~ /^(OR|\|)$/i) {
		#܂́i_ցj
		$hit_doc_list_bin = $hit_doc_list_bin | $doc_list_bin{$word};
	} elsif($controls{$word} =~ /^AND$/i) {
		#i_ρj
		$hit_doc_list_bin = $hit_doc_list_bin & $doc_list_bin{$word};
	} else {
		#i_ρj
		$hit_doc_list_bin = $hit_doc_list_bin & $doc_list_bin{$word};
	}
}
my @hit_doc_list = &ConvBin2List($hit_doc_list_bin);

#L[[hƂ̏oJEg
my %doc_freq_by_word;
for my $word (keys %doc_list_bin) {
	my $tmp = unpack("B*", $doc_list_bin{$word});
	$tmp =~ s/0//g;
	$doc_freq_by_word{$word} = length $tmp;
}

#Ƀqbg擾
my $hit_num = scalar @hit_doc_list;

#eDBMI[v
my(%pathes, %titles, %contents);
if($hit_num) {
	tie %pathes, "DB_File", "$CONF{'INDEX_DIR'}/file_no.cgi", O_RDONLY, 0644, $DB_HASH or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_no.cgi : $!");
	tie %titles, "DB_File", "$CONF{'INDEX_DIR'}/title.cgi", O_RDONLY, 0644, $DB_HASH or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/title.cgi : $!");
	tie %contents, "DB_File", "$CONF{'INDEX_DIR'}/content.cgi", O_RDONLY, 0644, $DB_HASH or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/content.cgi : $!");
}
#\/dݕtiLOj
my $sort = $q->param('sort');
unless($sort == 2 || $sort == 3) {
	$sort = 1;
}
my %doc_weight_hash;
if($hit_num) {
	if($sort == 1) {
		%doc_weight_hash = &CalcWeight(\@keyword_list, \%controls, \@hit_doc_list, \%hit_pos, \%doc_freq_by_word, \%pathes, \%titles);
	} elsif($sort == 2 || $sort == 3) {
		for my $fno (@hit_doc_list) {
			my @file_info = split(/\t/, $pathes{$fno});
			$doc_weight_hash{$fno} = $file_info[2];
		}
	}
}
#HTML𐶐
my $html = &ReadTemplate('./template/result.html');
my $item = &ReadTemplate('./template/item.html');
my $list;

#CfbNXĂ镶擾
my $total = 0;
if(open(FILE, "$CONF{'INDEX_DIR'}/file_num.cgi")) {
	$total = <FILE>;
	close(FILE);
}
#ŏICfbNXt擾
my $last_modifiled_date_ref = &GetLastModifiedDate;

#euwqu
$html =~ s/\$KEYWORD\$/${keyword}/g;
$html =~ s/\$SEARCH_URL\$/${CGI_URL}/g;
$html =~ s/\$TOTAL\$/${total}/g;
$html =~ s/\$HIT\$/${hit_num}/g;
$html =~ s/\$LAST_MODIFIED_YYYY\$/$last_modifiled_date_ref->{'YYYY'}/g;
$html =~ s/\$LAST_MODIFIED_MM\$/$last_modifiled_date_ref->{'MM'}/g;
$html =~ s/\$LAST_MODIFIED_DD\$/$last_modifiled_date_ref->{'DD'}/g;
$html =~ s/\$LAST_MODIFIED_M\$/$last_modifiled_date_ref->{'M'}/g;
$html =~ s/\$LAST_MODIFIED_D\$/$last_modifiled_date_ref->{'D'}/g;
$html =~ s/\$LAST_MODIFIED_WJ\$/$last_modifiled_date_ref->{'WJ'}/g;
$html =~ s/\$LAST_MODIFIED_WE\$/$last_modifiled_date_ref->{'WE'}/g;

#hLg[gURLݒAzzɓ
my %url_map;
my @roots = split(/\t/, $CONF{'DOCUMENT_ROOT'});
my @urls = split(/\t/, $CONF{'DOCUMENT_ROOT_URL'});
for(my $i=0;$i<@roots;$i++) {
	$url_map{$roots[$i]} = $urls[$i];
}
#ʂ1y[Wɕ\镶`
if(my $disp_num = $q->param('num')) {
	if($disp_num =~ /^\d+$/) {
		$CONF{'DISP_NUM'} = $disp_num;
	}
}

#\ɕԍבւāAzɊi[B
my $sort = $q->param('sort');
unless($sort == 2 || $sort == 3) {
	$sort = 1;
}
my @orderd_fno_list;
if($sort == 1) {
	#XRA[
	@orderd_fno_list = sort { $doc_weight_hash{$b} <=> $doc_weight_hash{$a} } keys %doc_weight_hash;
} elsif($sort == 2) {
	#XViVj
	@orderd_fno_list = sort { $doc_weight_hash{$b} <=> $doc_weight_hash{$a} } keys %doc_weight_hash;
} elsif($sort == 3) {
	#XViÂj
	@orderd_fno_list = sort { $doc_weight_hash{$a} <=> $doc_weight_hash{$b} } keys %doc_weight_hash;
}
#\Jnԍ擾
my $start_no = $q->param('start');
if($start_no !~ /^\d+$/) {
	$start_no = 0;
}
#\̏擾HTML
my $displayed_num = 0;
my $last_no = ${start_no} + $CONF{'DISP_NUM'};
if($hit_num <= $last_no) {
	$last_no = $hit_num;
}
for(my $i = ${start_no}; $i < ${last_no}; $i++) {
	my $fno = $orderd_fno_list[$i];
	#^Cg擾
	my $title = $titles{$fno};
	my($file_path, $size_b, $mtime, $csize) = split(/\t/, $pathes{$fno});
	my $size_kb = &RoundOff($size_b / 1024);
	if($size_kb == 0) {
		$size_kb = 1;
	}
	#Reciej𒊏o
	my $title_length = length $title;
	my @positions = @{$hit_pos{$fno}->{$keyword_list[0]}};
	my $first_hit_pos;
	for my $pos (@positions) {
		if($pos > $title_length) {
			$first_hit_pos = $pos;
			last;
		}
	}
	my $contents;
	if($first_hit_pos) {
		my $start_pos = $first_hit_pos - int($CONF{'DISP_CONTENTS_SIZE'} / 2);
		if($start_pos < $title_length) {
			$start_pos = $title_length;
		}
		my $delimiter_len = 2;
		my $dpos = rindex $contents{$fno}, 'B', $first_hit_pos;
		if($dpos < 0) {
			$dpos = rindex $contents{$fno}, '. ', $first_hit_pos;
		}
		if($dpos < 0) {
			$dpos = rindex $contents{$fno}, 'A', $first_hit_pos;
		}
		if($dpos < 0) {
			$dpos = rindex $contents{$fno}, ', ', $first_hit_pos;
		}
		if($dpos < 0) {
			$dpos = rindex $contents{$fno}, ' ', $first_hit_pos;
			$delimiter_len = 1;
		}
		if($dpos >= 0) {
			if($dpos >= $start_pos) {
				$start_pos = $dpos + $delimiter_len;
			} else {
				$start_pos = $first_hit_pos;
			}
		} else {
			$start_pos = $first_hit_pos;
		}
		$contents = substr($contents{$fno}, $start_pos, $CONF{'DISP_CONTENTS_SIZE'});

	} else {
		$contents = substr($contents{$fno}, $title_length, $CONF{'DISP_CONTENTS_SIZE'});
	}
	my @contents_chars = &SpritSjisChars(\$contents);
	$contents = join("", @contents_chars);
	my $date_ref = &ConvDispDateFromEpoch($mtime, $CONF{'TIMEZONE_OFFSET'});
	my $doc_url;
	for my $path (keys %url_map) {
		if($file_path =~ /^\Q${path}\E/) {
			$doc_url = $file_path;
			$doc_url =~ s/^\Q${path}\E//;
			$doc_url = $url_map{$path} . $doc_url;
			last;
		}
	}
	#f[^Tj^CWO
	$title = &SecureHtml($title);
	$contents = &SecureHtml($contents);
	#Rec̃L[[hFÂ
	if($CONF{'KEYWORD_COLOR'}) {
		for my $key (@keyword_list) {
			my $key = &SecureHtml($key);
			if($CONF{'CAPS_FLAG'}) {
				$contents =~ s/(\Q${key})\E/<font color=\"$CONF{'KEYWORD_COLOR'}\">$1<\/font>/g;
				$title =~ s/(\Q${key}\E)/<b>$1<\/b>/g;
			} else {
				$contents =~ s/(\Q${key}\E)/<font color=\"$CONF{'KEYWORD_COLOR'}\">$1<\/font>/ig;
				$title =~ s/(\Q${key}\E)/<b>$1<\/b>/ig;
			}
		}
	}
	#HTML𐶐
	my $item_html = $item;
	my $doc_no = $i + 1;
	$item_html =~ s/\$DOC_NO\$/${doc_no}/g;
	$item_html =~ s/\$DOC_TITLE\$/${title}/g;
	$item_html =~ s/\$SIZE_B\$/${size_b}/g;
	$item_html =~ s/\$SIZE_KB\$/${size_kb}/g;
	$item_html =~ s/\$CONTENTS\$/${contents}/g;
	$item_html =~ s/\$DOC_URL\$/${doc_url}/g;
	while( my($key, $value) = each %{$date_ref} ) {
		$item_html =~ s/\$${key}\$/${value}/g;
	}
	$item_html =~ s/\$SCORE\$/$doc_weight_hash{$fno}/g;
	$list .= $item_html;
	$displayed_num ++;
	if($displayed_num >= $CONF{'DISP_NUM'}) {
		last;
	}
}
$html =~ s/\$DISP_NUM\$/${displayed_num}/g;
$html =~ s/\$END\$/${last_no}/g;
my $disp_start_no = $start_no + 1;
if($hit_num) {
	$html =~ s/\$START\$/${disp_start_no}/g;
} else {
	$html =~ s/\$START\$/0/g;
}
$html =~ s/\$LIST\$/${list}/g;

#uOցvuցṽN̋ʃp[^
my $encoded_keyword = &UrlEncode($keyword);
my $common_param = "q=${encoded_keyword}&num=$CONF{'DISP_NUM'}&sort=${sort}";
#uOցvN
if($start_no > 0) {
	my $prev_start_no = $start_no - $CONF{'DISP_NUM'};
	my $link = "${CGI_URL}?start=${prev_start_no}&${common_param}";
	$html =~ s/\$PREV\$/<a href=\"${link}\">&lt;&lt;O<\/a>/g;
} else {
	$html =~ s/\$PREV\$//g;
}
#uցvN
if($last_no < $hit_num) {
	my $link = "${CGI_URL}?start=${last_no}&${common_param}";
	$html =~ s/\$NEXT\$/<a href=\"${link}\">&gt;&gt;<\/a>/g;
} else {
	$html =~ s/\$NEXT\$//g;
}

#y[WirQ[V𐶐
if($start_no > 0 || $last_no < $hit_num) {
	my $navi = &MakePageNavigationHtml($hit_num, $start_no, $common_param);
	$html =~ s/\$NAVI\$/${navi}/g;
} else {
	$html =~ s/\$NAVI\$//g;
}

untie %titles;
untie %pathes;
untie %contents;

my $lis_key;
if( open(LIS, "./conf/license.cgi") ) {
	($lis_key) = <LIS>;
	close(LIS);
}
my $lis = &DecodeSirialKey($lis_key);
unless($lis) {
	my $title = "\x81\x6d\x8e\x8e\x97\x70\x92\x86\x81\x69\x96\xa2\x93\x6f\x98\x5e\x81\x6a\x81\x6e\x91\x53\x95\xb6\x8c\x9f\x8d\xf5\x43\x47\x49\x20\x2d\x20\x66\x75\x74\x6f\x6d\x69\x27\x73\x20\x43\x47\x49\x20\x43\x61\x66\x65";
	if($html =~ /<title[^>]*>[^<]*<\/title>/i) {
		$html =~ s/<title[^>]*>[^<]*<\/title>/<title>${title}<\/title>/i;
	} else {
		if($html =~ /<\/head>/i) {
			$html =~ s/<\/head>/<title>${title}<\/title>\n<\/head>/i;
		}
	}
}
#ʂo
my $content_length = length $html;
print "Content-Type: text/html; charset=Shift_JIS\n";
print "Content-Length: ${content_length}\n";
print "\n";
print $html;
exit;

######################################################################

sub GetLastModifiedDate {
	open(FILE, "$CONF{'INDEX_DIR'}/lastmodified.cgi");
	my($epoch) = <FILE>;
	close(FILE);
	if($epoch) {
		my $date_ref = &ConvDispDateFromEpoch($epoch, $CONF{'TIMEZONE_OFFSET'});
		return $date_ref;
	}
	return;
}

sub MakePageNavigationHtml {
	my($hit_num, $start_no, $common_param) = @_;
	my $past_page_num = int($start_no / $CONF{'DISP_NUM'});
	my $this_page_no = $past_page_num + 1;
	my $last_page_no = int($hit_num / $CONF{'DISP_NUM'});
	if($hit_num % $CONF{'DISP_NUM'}) {
		$last_page_no ++;
	}
	my $navi_start = $this_page_no - 5;
	if($navi_start <= 0) {
		$navi_start = 1;
	}
	my $navi_html;
	for(my ${i}=${navi_start}; ${i}<=${navi_start}+10; ${i}++) {
		if(${i} > ${last_page_no}) {last;}
		if(${i} == ${this_page_no}) {
			$navi_html .= " ${i}";
		} else {
			my $page_start = ${i} * $CONF{'DISP_NUM'};
			$navi_html .= " <a href=\"${CGI_URL}?${common_param}&start=${page_start}\">${i}</a>";
		}
	}
	return $navi_html;
}

sub UrlEncode {
	my($string) = @_;
	#pXy[X"+"ɕϊ
	$string =~ s/ /+/g;
	#pp"+"łȂGR[h
	$string =~ s/([^A-Za-z0-9\+])/'%'.unpack("H2", $1)/ego;
	return $string;
}

sub CalcWeight {
	my($keyword_list_ref, $keyword_controls_ref, $doc_list_ref, $pos_ref, $doc_freq_by_word_ref, $file_info_ref, $titles_ref) = @_;
	#CfbNX擾
	open(CNT, "$CONF{'INDEX_DIR'}/file_num.cgi") or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_num.cgi : $!");
	my $indexed_doc_num = <CNT>;
	close(CNT);
	#Id(global weight) : px̋t(inverse documnt frequency; IDF)
	my $word_num = 0;
	my %global_weight;
	for my $word (@{$keyword_list_ref}) {
		if($keyword_controls_ref->{$word} eq '-') {
			next;
		}
		my $dfreq = $doc_freq_by_word_ref->{$word};	#px
		if($dfreq) {
			$global_weight{$word} = 1 + log( $indexed_doc_num / $dfreq );
		} else {
			$global_weight{$word} = 1;
		}
		$word_num ++;
	}
	#ď݂vZ
	my %weight;
	for my $fno (@{$doc_list_ref}) {
		my @file_info = split(/\t/, $file_info_ref->{$fno});
		my $csize = $file_info[3];
		my $title = $titles_ref->{$fno};
		#ǏId(local weight) : ΐpx(logarithmic TF)
		my %local_weight;
		my $weight_sum;
		for my $word (keys %global_weight) {
			if($keyword_controls_ref->{$word} eq '-') {
				next;
			}
			#L[[h̕ɂopx
			my $wfreq;
			if($pos_ref->{$fno}->{$word}) {
				$wfreq = scalar @{$pos_ref->{$fno}->{$word}};
			} else {
				$wfreq = 0;
			}
			#^CgɃL[[h܂܂Ă΁A{B
			if($pos_ref->{$fno}->{$word}->[0] < length $title) {
				$wfreq += $CONF{'TITLE_WEIGHT_MAGNIFICATION'} - 1;
			}
			#$local_weight{$word} = log(1 + $wfreq);	#KȂ
			$local_weight{$word} = ( 1 + log($wfreq) ) / log($csize);	#TCYŐK
			#[hƂ̏d݂vZ
			$weight_sum += $local_weight{$word} * $global_weight{$word};
		}
		#L[[hŜ̏d݂vZ(ϒlj
		$weight{$fno} = $weight_sum / $word_num;
	}
	return %weight;
}

sub ParseKeyword {
	my($keyword) = @_;
	#L[[hShift-JISɕϊ
	&Jcode::convert(\$keyword, 'sjis');
	#sR[h폜
	$keyword = &UnifyReturnCode($keyword);
	$keyword =~ s/\n//g;
	#SpXy[X𔼊pɕϊ
	$keyword =~ s/@/ /g;
	#A^u̔pXy[Xɕϊ
	$keyword =~ s/\t+/ /g;
	#ApXy[Xɕϊ
	$keyword =~ s/\s+/ /g;
	#O̔pXy[X폜
	$keyword =~ s/^\s//;
	$keyword =~ s/\s$//;
	#Spp𔼊pɕϊ
	unless($CONF{'ZEN_HAN_FLAG'}) {
		my @chars = &SpritSjisChars(\$keyword);
		$keyword = '';
		for my $char (@chars) {
			$keyword .= &SjisNumAlfa_Z2H($char);
		}
	}
	#p啶At@׃bgɕϊ
	unless($CONF{'CAPS_FLAG'}) {
		my @chars = &SpritSjisChars(\$keyword);
		$keyword = '';
		for my $char (@chars) {
			if($char =~ /^[A-Z]$/) {
				$char = lc $char;
			}
			$keyword .= $char;
		}
	}
	#L[[hXy[Xŕ
	&Jcode::convert(\$keyword, 'euc', 'sjis');
	my @elements = &Text::ParseWords::quotewords('\s', 1, $keyword);
	for(my $i=0;$i<@elements;$i++) {
		my $value = $elements[$i];
		&Jcode::convert(\$value, 'sjis', 'euc');
		$elements[$i] = $value;
	}
	#Xgbv[h𐳋K\ɕϊ
	my @stop_words_tmp = split(/\n/, $CONF{'STOP_WORDS'});
	my @stop_words;
	for my $word (@stop_words_tmp) {
		if($word eq '') {next;}
		#ASCII𔲂iƂł܂Ƃ߂Ēǉ邽߁j
		if($word =~ /^[\x20-\x7E]$/) {next;}
		$word = "\Q${word}\E";
		push(@stop_words, $word);
	}
	#ASCIIXgbv[hɒǉB
	for(my $i=32;$i<=126;$i++) {
		my $word = chr($i);
		$word = "\Q${word}\E";
		push(@stop_words, $word);
	}
	my $stop_words_exp = join("|", @stop_words);
	#L[[hXgbv[h폜
	my @new_elements;
	for my $word (@elements) {
		if($word =~ /^(${stop_words_exp})$/i) {
			next;
		} else {
			push(@new_elements, $word);
		}
	}
	return @new_elements;
}

sub SjisNumAlfa_Z2H {
	my($filestr) = @_;
	$filestr =~ s/\x82([\x4F-\x58]|[\x60-\x79]|[\x81-\x9A])/&sjis_num_alfa_z2h($1)/geo;
	sub sjis_num_alfa_z2h {
		my($c) = @_;
		#pɕϊ
		$c =~ tr/\x4F-\x58/\x30-\x39/;
		#p啶At@xbgɕϊ
		$c =~ tr/\x60-\x79/\x41-\x5A/;
		#pAt@xbgɕϊ
		$c =~ tr/\x81-\x9A/\x61-\x7A/;
		return $c;
	}
	return $filestr;
}

sub RoundOff {
	my($num, $place) = @_;
	#$placew肳ĂȂꍇɂ́A0Zbg
	if($place eq '' || $place eq '-0') {$place = 0;}
	if($place >= 0) {
		#_1ʈȉľܓꍇ
		$num = sprintf("%.${place}f", $num);
		return $num;
	} else {
		#1̈ʈȏľܓꍇ
		#ľܓ|Cg܂Ō
		$num = $num * (10 ** $place);
		#_1ʂľܓ
		$num = sprintf("%.0f", $num);
		#ɖ߂
		$num = $num * (10 ** abs($place));
		#ʂԂ
		return $num;
	}
}

sub ConvDispDateFromEpoch {
	my($epoch, $tz_offset) = @_;
	my(%hash, $week);
	($hash{'s'}, $hash{'m'}, $hash{'h'}, $hash{'D'}, $hash{'M'}, $hash{'YYYY'}, $week) = gmtime( $epoch + (${tz_offset} * 3600) );
	$hash{'YYYY'} += 1900;
	$hash{'M'} += 1;
	$hash{'YY'} = substr($hash{'YYYY'}, 2, 2);
	$hash{'MM'} = sprintf("%02d", $hash{'M'});
	$hash{'DD'} = sprintf("%02d", $hash{'D'});
	$hash{'hh'} = sprintf("%02d", $hash{'h'});
	$hash{'mm'} = sprintf("%02d", $hash{'m'});
	$hash{'ss'} = sprintf("%02d", $hash{'s'});
	my @wj_list = ('', '', '', '', '', '', 'y');
	my @we_list = ('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');
	$hash{'WJ'} = $wj_list[$week];
	$hash{'WE'} = $we_list[$week];
	return \%hash;
}

sub SearchKeywordFromDoc {
	my($fno, $word, $pos_ref) = @_;
	my @chars;
	if($CONF{'SPRIT_WORD_FLAG'} == 1) {
		@chars = &SpritSjisWords(\$word);
	} else {
		@chars = &SpritSjisChars(\$word);
	}
	my @word_length;
	$word_length[0] = 0;
	for(my $i=1;$i<@chars;$i++) {
		$word_length[$i] = $word_length[$i-1] + length($chars[$i-1]);
	}
	my $i = 0;
	my %char_pos_list;
	my %char_pos_num;
	for my $char (@chars) {
		my $pos_data = $pos_ref->{"${fno}\t${char}"};
		my @pos_list;
		my $pos_data_len = length($pos_data) / 2;
		for(my $i=0;$i<$pos_data_len;$i++) {
			push(@pos_list, unpack("n", substr($pos_data, $i * 2, 2)));
		}
		$char_pos_list{$i} = [@pos_list];
		$char_pos_num{$i} = scalar @pos_list;
		$i ++;
	}
	my %candidate;
	my $pre_no;
	for my $no (sort { $char_pos_num{$a} <=> $char_pos_num{$b} } keys %char_pos_num) {
		if($pre_no eq '') {
			for my $i (@{$char_pos_list{$no}}) {
				my $pos = $i - $word_length[$no];
				$candidate{$pos} ++;
			}
		} else {
			for my $p (keys %candidate) {
				my $hit_flag = 0;
				for my $i (@{$char_pos_list{$no}}) {
					if($i == $p + $word_length[$no]) {
						$hit_flag = 1;
					}
				}
				unless($hit_flag) {
					delete $candidate{$p};
				}
			}
		}
		$pre_no = $no;
	}
	return sort {$a <=> $b} keys %candidate;
}

sub ConvBin2List {
	my @bit_list = split(//, unpack("B*", $_[0]));
	my @list;
	my $i = 0;
	for my $bit (@bit_list) {
		if($bit) {
			push(@list, $i);
		}
		$i ++;
	}
	return @list;
}

sub SpritSjisWords {
	my($ref) = @_;
	$_ = $$ref;
	my @chars = /
		 [a-zA-Z]+               #ppP
		|[0-9]+                  #p
		|[\x20-\x7E]             #LȊOASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}

sub SpritSjisChars {
	my($ref) = @_;
	$_ = $$ref;
	my @chars = /
		 [\x20-\x7E]             #ASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}

sub UnifyReturnCode {
	my($String) = @_;
	$String =~ s/\x0D\x0A/\n/g;
	$String =~ s/\x0D/\n/g;
	$String =~ s/\x0A/\n/g;
	return $String;
}

sub SecureHtml {
	my($html) = @_;
	$html =~ s/\&amp;/\&/g;
	$html =~ s/\&/&amp;/g;
	$html =~ s/\"/&quot;/g;
	$html =~ s/</&lt;/g;
	$html =~ s/>/&gt;/g;
	return $html;
}

sub ReadTemplate {
	my($template) = @_;
	my $size = -s $template;
	if(!open(IN, "$template")) {
		&ErrorPrint2("ev[gt@C $template I[vł܂łB : $!");
	}
	binmode(IN);
	my $filestr;
	sysread(IN, $filestr, $size);
	close(IN);
	$filestr = &UnifyReturnCode($filestr);
	$filestr = &CopyRight($filestr);
	$filestr =~ s/\$CGI_URL\$/${CGI_URL}/g;
	return $filestr;
}

sub CopyRight {
	my($str) = @_;
	$str =~ s/\$COPYRIGHT\$/${COPYRIGHT}/g;
	$str =~ s/\$COPYRIGHT1\$/${COPYRIGHT1}/g;
	$str =~ s/\$COPYRIGHT2\$/${COPYRIGHT2}/g;
	$str =~ s/\$TITLE\$/${COPYRIGHT}/g;
	return $str;
}

sub ErrorPrint {
	my($message) = @_;
	my $html = &ReadTemplate("./template/admin/error.html");
	$html =~ s/\$error\$/$message/ig;
	$html = &CopyRight($html);
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub ErrorPrint2 {
	my($message) = @_;
	print "Content-Type: text/plain; charset=Shift_JIS\n";
	print "\n";
	print $message;
	exit;
}

sub GetThisFileName {
	my $string;
	if($ENV{'SCRIPT_NAME'}) {
		$string = $ENV{'SCRIPT_NAME'};
	} elsif($ENV{'REQUEST_URI'}) {
		$string = $ENV{'REQUEST_URI'};
	} else {
		return 'admin.cgi';
	}
	my($part) = split(/\?/, $string);
	my @parts = split(/\//, $part);
	my $script_name = pop @parts;
	return $script_name;
}

sub GetConf {
	my($file) = @_;
	my %data;
	open(FILE, "$file") || &ErrorPrint("ݒt@C $file I[vł܂łB: $!");
	while(<FILE>) {
		if(/^([^\t]+)\t(.*)/) {
			$data{$1} = $2;
		}
	}
	close(FILE);
	return %data;
}

sub DecodeSirialKey {
	my($sirial) = @_;
	if($sirial eq '') {return;}
	if($sirial =~ /[^0-9a-zA-Z\-\t\s]/) {
		return;
	}
	my @parts = split(/[\-\t\s]/, $sirial);
	my $sirial;
	for my $part (@parts) {
		if($part eq '') {return;}
		$part = unpack("n", pack("H4", $part));
		$part = sqrt($part);
		if($part % 1) {
			return;
		}
		$part = sprintf("%02lx", $part);
		$sirial .= $part;
	}
	$sirial = hex $sirial;
	my $license = ($sirial - 12345) / 98765;
	if($license <= 0) {return;}
	my $int_value = int $license;
	if( $license - $int_value != 0 ) {return;}
	return $license;
}
