#!/usr/bin/perl
######################################################################
# SCGI Ver 1.0.0
# iCfbNXpXNvgj
# Copyright(C) futomi 2005
# http://www.futomi.com/
######################################################################
use strict;
BEGIN {
	use FindBin qw($Bin);
	chdir $FindBin::Bin;
	use lib "$FindBin::Bin/lib";
	use CGI;
	use CGI::Carp qw(fatalsToBrowser);
	use FCC::Apache::Session;
	use Jcode;
	unless (eval "use Fcntl; 1") {
		print "Content-Type: text/plain\n\n";
		print "FcntlW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
	unless (eval "use DB_File; 1") {
		print "Content-Type: text/plain\n\n";
		print "DB_FileW[T[oɃCXg[ĂȂ߁Ap܂B\n$@";
		exit;
	}
}
$| = 1;
my $q = new CGI;
my $VERSION = '1.0.0';
#Copyright
my $COPYRIGHT = "futomi's CGI Cafe - SCGI $VERSION";
my $COPYRIGHT1 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">futomi\'s CGI Cafe</a>";
my $COPYRIGHT2 = "<a href=\"http://www.futomi.com/\" target=\"_blank\">${COPYRIGHT}</a>";

######################################################################

#CGIt@C̃t@C擾
my $CGI_URL = &GetThisFileName;

#Cookie
my $COOKIE_NAME = 'session';

#ݒf[^擾
my %CONF = &GetConf('./conf/config.cgi');

##̎QƃXgi[Azz̒`
my %CHAR_ENT_REF;

#e̎擾
my $action = $q->param('a');

#F
my %cookies = &GetCookie;
my $sid = $cookies{$COOKIE_NAME};
my %session_data;
my $session;
if($sid) {
	&SessionAuth($sid, \%session_data);
} else {
	&ErrorPrint("sȃANZXłB");
}

if($action eq 'start') {
	if( $q->param('init') ) {
		&PrintProgress("${CGI_URL}?a=init", 0, "OFCfbNX", 0);
	} else {
		&PrintProgress("${CGI_URL}?a=flist", 0, "OFt@Cꗗ擾", 0);
	}
} elsif($action eq 'abort') {
	&PrintAbort;
} elsif($action eq 'init') {
	#iCfbNXt@C폜j
	&InitIndexDbm;
	&PrintProgress("${CGI_URL}?a=flist", 0, 'OFt@Cꗗ擾', 0);
} elsif($action eq 'flist') {
	#t@C擾e|DBMɊi[
	my $target_num = &MakeFileListTmp;
	my $license_key = &ReadTextFile("./conf/license.cgi");
	my $license = &DecodeSirialKey($license_key);
	my $max_page = 100;
	if($license> 0) {
		$max_page = $license;
	}
	if($target_num > $max_page) {
		my $msg;
		$msg .= "<p>CfbNXΏۃt@CACZX𒴂Ă邽߁A𒆒f܂B</p>\n";
		$msg .= "<table border=\"0\">\n";
		$msg .= "  <tr><td>Eo</td><td>F</td><td>${target_num}</td></tr>\n";
		if($license) {
			$msg .= "  <tr><td>ECZX</td><td>F</td><td>${max_page} <font color=\"green\">io^ρj</font></td></tr>\n";
		} else {
			$msg .= "  <tr><td>ECZX</td><td>F</td><td>${max_page} <font color=\"red\">ipFo^j</font></td></tr>\n";
		}
		$msg .= "</table>\n";
		$msg .= "<p>õCfbNX쐬ꍇɂ́A<a href=\"http://www.futomi.com/library/share.html\" target=\"_blank\">CZXǉw</a>B</p>\n";
		$msg .= "<p>CZX𖢍w̕ŁA{CGI]ꍇɂ́AuVXeݒvj[́ui[fBNgvw藓ŁACZX͈͓̔̃t@Ci[ĂfBNgɌ肵Ăw艺B</p>\n";
		&ErrorPrint("${msg}");
	}

	&PrintProgress("${CGI_URL}?a=chkfiles", 0, 'OFVK/XV/폜t@C𒊏o', 0);
} elsif($action eq 'chkfiles') {
	#VK/XV/폜t@C̃XgDBMie|[j𐶐
	my($new_num, $mod_num, $del_num) = &CheckUpdatedFiles;
	#&ErrorPrint("  ${new_num}̐VKA${mod_num}̍XVA${del_num}̍폜܂B");
	&PrintProgress("${CGI_URL}?a=delfileindex", 0, 'OF폜̃CfbNX폜', 0);
} elsif($action eq 'delfileindex') {
	my %updated_file_num = &GetConf("$CONF{'INDEX_DIR'}/update_filenum_file.cgi");
	if($updated_file_num{'DEL'} > 0) {
		#폜t@C̃CfbNX폜
		&DelChangedFileIndex("$CONF{'INDEX_DIR'}/file_del.tmp.cgi");
	}
	&PrintProgress("${CGI_URL}?a=modfileindex", 0, 'OFXṼCfbNX폜', 0);
} elsif($action eq 'modfileindex') {
	my %updated_file_num = &GetConf("$CONF{'INDEX_DIR'}/update_filenum_file.cgi");
	if($updated_file_num{'MOD'} > 0) {
		#XVt@C̃CfbNX폜
		&DelChangedFileIndex("$CONF{'INDEX_DIR'}/file_mod.tmp.cgi");
	}
	#ԍŏ̃t@CpX擾
	if($updated_file_num{'LST'} > 0) {
		my %lst;
		my $lst_dbm = "$CONF{'INDEX_DIR'}/file_lst.tmp.cgi";
		tie %lst, "DB_File", "$lst_dbm" or &ErrorPrint("Can't open $lst_dbm : $!");
		unless(exists $lst{'1'}) {
			&ErrorPrint("w̃t@Cԍ݂͑܂B");
		}
		my $file_path = $lst{'1'};
		my %updated_file_num = &GetConf("$CONF{'INDEX_DIR'}/update_filenum_file.cgi");
		my $all_num = $updated_file_num{'LST'};
		&PrintProgress("${CGI_URL}?a=mkindex&n=1", 0, "CfbNX\\z 1/${all_num} ${file_path}", 0);
	} else {
		&PrintProgress("${CGI_URL}?a=finish", 100, 'dグ', 0);
	}
} elsif($action eq 'mkindex') {
	my $n = $q->param('n');
	if($n eq '') {
		&ErrorPrint("ׂt@Cԍ̎w肪܂B");
	}
	my %updated_file_num = &GetConf("$CONF{'INDEX_DIR'}/update_filenum_file.cgi");
	my $all_num = $updated_file_num{'LST'};
	if($n > $all_num) {
		&ErrorPrint("ׂt@Cԍ擾t@CXg̐𒴂Ă܂B");
	}
	#t@CpX擾
	my %lst;
	my $lst_dbm = "$CONF{'INDEX_DIR'}/file_lst.tmp.cgi";
	tie %lst, "DB_File", "$lst_dbm" or &ErrorPrint("Can't open $lst_dbm : $!");
	unless(exists $lst{$n}) {
		&ErrorPrint("w̃t@Cԍ݂͑܂B");
	}
	my $file_path = $lst{$n};
	#CfbNXXV
	&UpdateIndexes($file_path);
	my $next_n = $n + 1;
	if($next_n <= $all_num) {
		my $rate = int( ${n} * 100 / ${all_num} );
		my $next_file_path = $lst{$next_n};
		untie %lst;
		&PrintProgress("${CGI_URL}?a=mkindex&n=${next_n}", ${rate}, "CfbNX\\z ${next_n}/${all_num} ${next_file_path}", 0);
	} else {
		untie %lst;
		&PrintProgress("${CGI_URL}?a=finish", 100, 'dグ', 0);
	}

} elsif($action eq 'finish') {
	my %updated_file_num = &GetConf("$CONF{'INDEX_DIR'}/update_filenum_file.cgi");
	my $new_num = $updated_file_num{'NEW'};
	my $del_num = $updated_file_num{'DEL'};
	#CfbNXt@CɋL^
	my $indexed_file_num = 0;
	if(-e "$CONF{'INDEX_DIR'}/file_num.cgi") {
		open(CNT, "+<$CONF{'INDEX_DIR'}/file_num.cgi") or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_num.cgi : $!");
		$indexed_file_num = <CNT>;
		truncate CNT, 0;
		seek CNT, 0, 0;
	} else {
		open(CNT, ">$CONF{'INDEX_DIR'}/file_num.cgi") or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_num.cgi : $!");
	}
	$indexed_file_num = $indexed_file_num + $new_num - $del_num;
	print CNT $indexed_file_num;
	close(CNT);
	#ŏICfbNXtf[^XV
	&UpdateLastModifiedData;
	#e|[t@C폜
	&DeleteTemporaryFiles;
	&PrintProgressComplete('CfbNX\z܂B');
} else {
	&ErrorPrint("sȃANZXł");
}
exit;


######################################################################

sub UpdateLastModifiedData {
	open(FILE, ">$CONF{'INDEX_DIR'}/lastmodified.cgi");
	print FILE time;
	close(FILE);
}

sub PrintAbort {
	my($caption) = @_;
	my $html = &ReadTemplate('./template/admin/mkindex_abort.html');
	print "Cache-Control: no-cache\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub DeleteTemporaryFiles {
	unlink "$CONF{'INDEX_DIR'}/file.tmp.cgi";
	unlink "$CONF{'INDEX_DIR'}/file_del.tmp.cgi";
	unlink "$CONF{'INDEX_DIR'}/file_mod.tmp.cgi";
	unlink "$CONF{'INDEX_DIR'}/file_lst.tmp.cgi";
	unlink "$CONF{'INDEX_DIR'}/update_filenum_file.cgi";
}

sub UpdateIndexes {
	my($file_path) = @_;
	##̎QƃXg擾
	%CHAR_ENT_REF = &GetCharEntRef;
	#t@Ci[DBMI[v
	my %files;
	tie %files, "DB_File", "$CONF{'INDEX_DIR'}/file_no.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_no.cgi : $!");
	#t@CpXi[DBMI[v
	my %file_rev;
	tie %file_rev, "DB_File", "$CONF{'INDEX_DIR'}/file_rev.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_rev.cgi");
	#CfbNXiSji[DBMI[v
	my %indexes;
	tie %indexes, "DB_File", "$CONF{'INDEX_DIR'}/index.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/index.cgi : $!");
	#^Cgi[DBMI[v
	my %titles;
	tie %titles, "DB_File", "$CONF{'INDEX_DIR'}/title.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/title.cgi : $!");
	#t@CReci[DBMI[v
	my %contents;
	tie %contents, "DB_File", "$CONF{'INDEX_DIR'}/content.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/content.cgi : $!");
	#L[[hʒui[DBMI[v
	my %positions;
	tie %positions, "DB_File", "$CONF{'INDEX_DIR'}/pos.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/pos.cgi : $!");
	#Ht@CԍXgDBMI[v
	my %worm_hole_fno;
	tie %worm_hole_fno, "DB_File", "$CONF{'INDEX_DIR'}/worm_hole_fno.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/worm_hole_fno.cgi : $!");
	my @worm_hole_fno_list = keys %worm_hole_fno;
	#OXgDBMI[v
	my %grams;
	tie %grams, "DB_File", "$CONF{'INDEX_DIR'}/gram.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/gram.cgi : $!");
	#ŏIt@Cԍ擾
	my $lastfno;
	if(-e "$CONF{'INDEX_DIR'}/lastfno.cgi") {
		open(FNO, "$CONF{'INDEX_DIR'}/lastfno.cgi");
		$lastfno = <FNO>;
		close(FNO);
	}
	#t@Cԍ肷B
	my $no;
	if(@worm_hole_fno_list) {
		$no = shift @worm_hole_fno_list;
		delete $worm_hole_fno{$no};
	} else {
		if($lastfno eq '') {
			$no = 0;
		} else {
			$no = $lastfno + 1;
		}
		$lastfno = $no;
	}
	#t@CǂݍށiShift-JISϊAs폜A^O폜j
	my $content = &ReadFile($no, "${file_path}", \%titles);
	#t@CRec̃TCY߂
	my $csize = length $content;
	#t@CTCY߂
	my $fsize = -s "${file_path}";
	my $mtime = (stat("${file_path}"))[9];
	#t@Ci[DBMɏ
	$files{$no} = "${file_path}\t${fsize}\t${mtime}\t${csize}";
	#t@CpXi[DBMɏ
	$file_rev{$file_path} = $no;
	#CfbNXijOɂ\zj
	&MakeIndex($no, \%indexes, \%positions, \$content, \%grams);
	#Hꂽt@C̓eDBMɏ
	$contents{$no} = $content;
	undef $content;

	#ŏIt@CԍXV
	open(FNO, ">$CONF{'INDEX_DIR'}/lastfno.cgi") || &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/lastfno.cgi : $!");
	print FNO $lastfno;
	close(FNO);
	#eDBMN[Y
	untie %files;
	untie %file_rev;
	untie %indexes;
	untie %titles;
	untie %contents;
	untie %positions;
	untie %grams;
}

sub MakeFileListTmp {
	my $dbm = "$CONF{'INDEX_DIR'}/file.tmp.cgi";
	#e|[DBMt@C폜
	unlink $dbm;
	#AzzDBM֘At
	my %files_tmp;
	tie %files_tmp, "DB_File", "$dbm" or &ErrorPrint("Can't open $dbm : $!");
	#t@CꗗoAAzzɊi[B
	my @exclude_dirs_list = split(/\t/, $CONF{'EXCLUDE_DIR'});
	my @roots = split(/\t/, $CONF{'DOCUMENT_ROOT'});
	my $target_num = 0;
	for my $root (@roots) {
		my $n = &GetFileList($root, \%files_tmp, \@exclude_dirs_list);
		$target_num += $n;
	}
	#DBMuntie
	untie %files_tmp;
	return $target_num;
}

sub DelChangedFileIndex {
	my($changed_dbm) = @_;
	my %changed_files;
	tie %changed_files, "DB_File", "$changed_dbm" or &ErrorPrint("Can't open $changed_dbm : $!");
	my %file_rev;
	tie %file_rev, "DB_File", "$CONF{'INDEX_DIR'}/file_rev.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_rev.cgi");
	my %file_info;
	tie %file_info, "DB_File", "$CONF{'INDEX_DIR'}/file_no.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/file_no.cgi");
	my %titles;
	tie %titles, "DB_File", "$CONF{'INDEX_DIR'}/title.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/title.cgi");
	my %contents;
	tie %contents, "DB_File", "$CONF{'INDEX_DIR'}/content.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/content.cgi");
	my %pos;
	tie %pos, "DB_File", "$CONF{'INDEX_DIR'}/pos.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/pos.cgi");
	my %worm_hole_fno;
	tie %worm_hole_fno, "DB_File", "$CONF{'INDEX_DIR'}/worm_hole_fno.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/worm_hole_fno.cgi : $!");
	my %grams;
	tie %grams, "DB_File", "$CONF{'INDEX_DIR'}/gram.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/gram.cgi : $!");
	my $del_index_bin;
	while( my($path, $value) = each %changed_files ) {
		if(exists $file_rev{$path}) {
			my $fno = $file_rev{$path};
			delete $file_info{$fno};
			delete $titles{$fno};
			delete $contents{$fno};
			#while( my($key, $pos_data) = each %pos) {
			#	if($key =~ /^${fno}\t/) {
			#		delete $pos{$key};
			#	}
			#}
			my @gram_list = split(/\t/, $grams{$fno});
			while( my $gram = shift @gram_list ) {
				delete $pos{"${fno}\t${gram}"};
			}
			my $fno_bin = &MakeFileNoBin($fno);
			$del_index_bin = $del_index_bin | $fno_bin;
			delete $file_rev{$path};
			$worm_hole_fno{$fno} ++;
		}
	}
	untie %changed_files;
	untie %file_rev;
	untie %file_info;
	untie %titles;
	untie %contents;
	untie %pos;
	untie %worm_hole_fno;
	untie %grams;
	my %indexes;
	tie %indexes, "DB_File", "$CONF{'INDEX_DIR'}/index.cgi" or &ErrorPrint("Can't open $CONF{'INDEX_DIR'}/index.cgi");
	while( my($gram, $index_bin) = each %indexes ) {
		$indexes{$gram} = ($index_bin ^ $del_index_bin) & $index_bin;
	}
	untie %indexes;
}

sub CheckUpdatedFiles {
	my $rev_dbm = "$CONF{'INDEX_DIR'}/file_rev.cgi";
	my $tmp_dbm = "$CONF{'INDEX_DIR'}/file.tmp.cgi";
	my $mod_dbm = "$CONF{'INDEX_DIR'}/file_mod.tmp.cgi"; 
	my $del_dbm = "$CONF{'INDEX_DIR'}/file_del.tmp.cgi";
	my $lst_dbm = "$CONF{'INDEX_DIR'}/file_lst.tmp.cgi";
	my $finfo_dbm = "$CONF{'INDEX_DIR'}/file_no.cgi";
	#VKEXVE폜t@CDBM폜
	unlink $mod_dbm;
	unlink $del_dbm;
	#eDBMAzzɊ֘At
	my(%rev, %tmp, %new, %mod, %del, %lst, %finfo);
	tie %rev, "DB_File", "$rev_dbm" or &ErrorPrint("Can't open $rev_dbm : $!");
	tie %tmp, "DB_File", "$tmp_dbm" or &ErrorPrint("Can't open $tmp_dbm : $!");
	tie %mod, "DB_File", "$mod_dbm" or &ErrorPrint("Can't open $mod_dbm : $!");
	tie %del, "DB_File", "$del_dbm" or &ErrorPrint("Can't open $del_dbm : $!");
	tie %lst, "DB_File", "$lst_dbm" or &ErrorPrint("Can't open $lst_dbm : $!");
	tie %finfo, "DB_File", "$finfo_dbm" or &ErrorPrint("Can't open $finfo_dbm : $!");
	#JE^[
	my $new_num = 0;
	my $mod_num = 0;
	my $del_num = 0;
	my $lst_num = 0;
	#폜ƂȂt@C
	while( my($path, $data) = each %rev) {
		unless(exists $tmp{$path}) {
			$del{$path} = $data;
			$del_num ++;
		}
	}
	#VKƍXVt@CB
	while( my($path, $data) = each %tmp) {
		if(exists $rev{$path}) {
			my $fno = $rev{$path};
			my($dummy1, $old_size, $old_mtime) = split(/\t/, $finfo{$fno});
			my($new_size, $new_mtime) = split(/\t/, $tmp{$path});
			if($old_size != $new_size || $old_mtime != $new_mtime) {
				$mod{$path} = $tmp{$path};
				$mod_num ++;
				$lst_num ++;
				$lst{$lst_num} = $path;
			}
		} else {
			$new_num ++;
			$lst_num ++;
			$lst{$lst_num} = $path;
		}
	}
	untie %rev;
	untie %mod;
	untie %del;
	untie %lst;
	#t@CAt@CɋL^
	my $update_filenum_file = "$CONF{'INDEX_DIR'}/update_filenum_file.cgi";
	open(FILE, ">${update_filenum_file}") or &ErrorPrint("Can't open ${update_filenum_file} : $!");
	print FILE "NEW\t${new_num}\n";
	print FILE "MOD\t${mod_num}\n";
	print FILE "DEL\t${del_num}\n";
	print FILE "LST\t${lst_num}\n";
	close(FILE);
	#lԂ
	return $new_num, $mod_num, $del_num, $lst_num;
}

sub GetFileList {
	my($path, $data_ref, $exclude_dirs_ref) = @_;
	#CfbNXOfBNgr
	my $ex_flag = 0;
	if(@{$exclude_dirs_ref}) {
		for my $ex_path (@{$exclude_dirs_ref}) {
			if($path =~ /^\Q${ex_path}\E/) {
				$ex_flag = 1;
				last;
			}
		}
	}
	if($ex_flag) {
		return;
	}
	#wpX̃t@CAfBNgꗗo
	opendir(DIR, "$path");
	my @files = readdir(DIR);
	closedir(DIR);
	#CfbNXΏۊgq̐ݒf[^𐳋K\ɕϊ
	my @exts = split(/\t/, $CONF{'EXT'});
	my $ext_exp = join("|", @exts);
	#ot@CAfBNgƂɏ{
	my $target_num = 0;
	for my $file (@files) {
		#JgfBNgAefBNg͖
		if($file =~ /^\.?\.$/) {next;}
		#fBNgꍇ̏
		if(-d "${path}/${file}") {
			#ċAsATufBNg𒲂ׂ
			my $n= &GetFileList("${path}/${file}", $data_ref, $exclude_dirs_ref);
			$target_num += $n;
		#ΏۊgqŁAeLXgt@CꍇB
		} elsif($file =~ /(${ext_exp})$/) {
			my $fsize = -s "${path}/${file}";	#t@CTCY
			my $mtime = (stat("${path}/${file}"))[9];	#ŏIXV
			my $key = "${path}/${file}";
			$data_ref->{"$key"} = "${fsize}\t${mtime}";
			$target_num ++;
		}
	}
	return $target_num;
}

sub InitIndexDbm {
	opendir(DIR, "$CONF{'INDEX_DIR'}") or &ErrorPrint("Can't open $CONF{'INDEX_DIR'} : $!");
	my @index_files = readdir(DIR);
	closedir(DIR);
	for my $f (@index_files) {
		if($f =~ /\.cgi$/) {
			unlink "$CONF{'INDEX_DIR'}/${f}";
		}
	}
}

sub MakeFileNoBin {
	my($file_no) = @_;
	my $file_no_bin;
	my $chunk_pos = int( $file_no / 32 );
	my $all_zero_chunk = pack("N", 0);
	for(my $i=0;$i<=$chunk_pos;$i++) {
		if($i == $chunk_pos) {
			my $amari = $file_no % 32;
			#my $chunk = 0b10000000000000000000000000000000 >> $amari;
			my $chunk = unpack("N", pack("B32", '10000000000000000000000000000000')) >> $amari;
			$file_no_bin .= pack("N", $chunk);
		} else {
			$file_no_bin .= $all_zero_chunk;
		}
	}
	return $file_no_bin;
}

sub MakeIndex {
	my($file_no, $indexes_ref, $positions_ref, $content_ref, $gram_ref) = @_;
	#1Ƃɕ
	my @chars;
	if($CONF{'SPRIT_WORD_FLAG'} == 1) {
		@chars = &SpritSjisWords($content_ref);
	} else {
		@chars = &SpritSjisChars($content_ref);
	}
	#t@Cԍ\CfbNX𐶐it@Cԍ̈ʒu1łȊO0j
	my $file_no_bin = &MakeFileNoBin($file_no);
	my $position = 0;
	my(%pos_hash, %index_hash, %gram_hash);
	for my $char (@chars) {
		if($CONF{'CAPS_FLAG'} != 1 && $char =~ /^[a-zA-Z]+$/) {
			$char = lc $char;
		}
		$index_hash{$char} = $indexes_ref->{$char} | $file_no_bin;
		$pos_hash{"${file_no}\t${char}"} .= pack("n", $position);
		$position += length($char);
		$gram_hash{$char} = 1;
	}
	undef @chars;
	while( my($key, $value) = each %pos_hash ) {
		$positions_ref->{$key} = $value;
	}
	undef %pos_hash;
	while( my($key, $value) = each %index_hash ) {
		$indexes_ref->{$key} = $value;
	}
	undef %index_hash;
	my @gram_list = keys %gram_hash;
	$gram_ref->{$file_no} = join( "\t", keys(%gram_hash) );
	undef %gram_hash;
}

sub SpritSjisWords {
	my($ref) = @_;
	$_ = $$ref;
	my @chars = /
		 [a-zA-Z]+                     #ppPi)
		|[0-9]+                     #p
		|[\x20-\x7E]             #LȊOASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}

sub SpritSjisChars {
	my($ref) = @_;
	$_ = $$ref;
	my @chars = /
		 [\x20-\x7E]             #ASCII
		|[\xA1-\xDF]             #pJ^Ji
		|[\x81-\x9F][\x40-\xFC]  #2oCg
		|[\xE0-\xEF][\x40-\xFC]  #2oCg
	/gox;
	return @chars;
}

sub ReadFile {
	my($fno, $file, $title_ref) = @_;
	my $size = -s $file;
	if(!open(IN, "$file")) {
		&ErrorPrint("$file I[vł܂łB : $!");
	}
	#ǂݍ݃TCY
	if($CONF{'READ_DOC_SIZE'} > 0) {
		if($size > $CONF{'READ_DOC_SIZE'}) {
			$size = $CONF{'READ_DOC_SIZE'};
		}
	}
	#t@Cǂݍ
	binmode(IN);
	my $filestr;
	sysread(IN, $filestr, $size);
	close(IN);
	#Shift-JISɕϊ
	&Jcode::convert(\$filestr, 'sjis');
	#sR[h폜
	$filestr = &UnifyReturnCode($filestr);
	$filestr =~ s/\n//g;
	#HTML̏ꍇAeLXgϊāA^CgƖ{擾
	my $title;
	if($file =~ /\.(html|htm|shtml|php|asp|jsp)$/i) {
		($title, $filestr) = &Html2Text($filestr);
	}
	#SpXy[X𔼊pɕϊ
	$filestr =~ s/@/ /g;
	$title =~ s/@/ /g;
	#A^u̔pXy[Xɕϊ
	$filestr =~ s/\t+/ /g;
	$title =~ s/\t+/ /g;
	#ApXy[Xɕϊ
	$filestr =~ s/\s+/ /g;
	$title =~ s/\s+/ /g;
	#Spp𔼊pɕϊ
	unless($CONF{'ZEN_HAN_FLAG'}) {
		my @filestr_chars = &SpritSjisChars(\$filestr);
		$filestr = '';
		for my $char (@filestr_chars) {
			$filestr .= &SjisNumAlfa_Z2H($char);
		}
		undef @filestr_chars;
		my @title_chars = &SpritSjisChars(\$title);
		$title = '';
		for my $char (@title_chars) {
			$title .= &SjisNumAlfa_Z2H($char);
		}
		undef @title_chars;
	}
	#^CgDBMɏ
	$title_ref->{$fno} = $title;
	#擪Ƀ^CgtĕԂ
	return "${title}${filestr}";
}

sub SjisNumAlfa_Z2H {
	my($filestr) = @_;
	$filestr =~ s/\x82([\x4F-\x58]|[\x60-\x79]|[\x81-\x9A])/&sjis_num_alfa_z2h($1)/geo;
	sub sjis_num_alfa_z2h {
		my($c) = @_;
		#pɕϊ
		$c =~ tr/\x4F-\x58/\x30-\x39/;
		#p啶At@xbgɕϊ
		$c =~ tr/\x60-\x79/\x41-\x5A/;
		#pAt@xbgɕϊ
		$c =~ tr/\x81-\x9A/\x61-\x7A/;
		return $c;
	}
	return $filestr;
}

sub Html2Text {
	my($html) = @_;
	#^Cgo
	my $title;
	if($html =~ /\Q$CONF{'TITLE_START_TAG'}\E(.+?)\Q$CONF{'TITLE_END_TAG'}\E/i) {
		$title = $1;
	}
	#head^O폜
	$html =~ s/<head>.*?<\/head>//;
	#ASP/JSP폜
	$html =~ s/<\%.*?\%>//g;
	#PHP폜
	$html =~ s/<\?php.*?\?>//ig;
	#JavaScript폜
	$html =~ s/<script[^>]*>.*?<\/script>//ig;
	$html =~ s/<noscript>.*?<\/noscript>//ig;
	#^O폜
	$html =~ s/<!\-\-.*?\-\->//g;
	$html =~ s/<.*?>//g;
	#̎Qƕϊ
	while( my($key, $value) = each %CHAR_ENT_REF ) {
		$html =~ s/\Q${key}\E/${value}/ig;
	}
	return $title, $html;
}

sub UnifyReturnCode {
	my($String) = @_;
	$String =~ s/\x0D\x0A/\n/g;
	$String =~ s/\x0D/\n/g;
	$String =~ s/\x0A/\n/g;
	return $String;
}

sub GetCharEntRef {
	my $data_file = './lib/char_ent_ref.dat';
	open(FILE, "$data_file") or &ErrorPrint("Can't open $data_file : $!");
	my %hash;
	while(<FILE>) {
		if(/^([^\t]+)\t(.+)/) {
			$hash{$1} = $2;
		}
	}
	close(FILE);
	return %hash;
}

sub PrintProgress {
	my($url, $rate, $caption, $wait) = @_;
	if($wait eq '') {$wait = 0;}
	my $meta_refresh = "<meta http-equiv=\"refresh\" content=\"${wait}; url=${url}\">";
	my $html = &ReadTemplate('./template/admin/progress.html');
	$html =~ s/\$RATE\$/$rate/g;
	if($url eq '') {
		$html =~ s/\$META_REFRESH\$//g;
	} else {
		$html =~ s/\$META_REFRESH\$/$meta_refresh/g;
	}
	$html =~ s/\$CAPTION\$/$caption/g;
	print "Cache-Control: no-cache\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub PrintProgressComplete {
	my($caption) = @_;
	my $html = &ReadTemplate('./template/admin/progress_complete.html');
	$html =~ s/\$CAPTION\$/$caption/g;
	print "Cache-Control: no-cache\n";
	print $q->header(-type=>'text/html; charset=Shift_JIS');
	print $html;
	exit;
}

sub SessionAuth {
	my($sid, $session_data_ref) = @_;
	my $session = new FCC::Apache::Session("./session");
	%{$session_data_ref} = $session->sessoin_auth($sid);
	unless($session_data_ref->{_sid}) {
		my $err = "F؂Ɏs܂B<br>\n" . $session->error();
		print &ClearCookie($COOKIE_NAME);
		print "Content-Type: text/plain\n";
		print "\n";
		print "$err";
		exit;
	}
	return $session;
}

sub GetConf {
	my($file) = @_;
	my %data;
	open(FILE, "$file") || &ErrorPrint("ݒt@C $file I[vł܂łB: $!");
	while(<FILE>) {
		if(/^([^\t]+)\t(.*)/) {
			$data{$1} = $2;
		}
	}
	close(FILE);
	return %data;
}

sub ReadTemplate {
	my($template) = @_;
	my $size = -s $template;
	if(!open(IN, "$template")) {
		&ErrorPrint2("ev[gt@C $template I[vł܂łB : $!");
	}
	binmode(IN);
	my $filestr;
	sysread(IN, $filestr, $size);
	close(IN);
	$filestr = &UnifyReturnCode($filestr);
	$filestr = &CopyRight($filestr);
	$filestr =~ s/\$CGI_URL\$/${CGI_URL}/g;
	return $filestr;
}

sub CopyRight {
	my($str) = @_;
	$str =~ s/\$COPYRIGHT\$/${COPYRIGHT}/g;
	$str =~ s/\$COPYRIGHT1\$/${COPYRIGHT1}/g;
	$str =~ s/\$COPYRIGHT2\$/${COPYRIGHT2}/g;
	$str =~ s/\$TITLE\$/${COPYRIGHT}/g;
	return $str;
}

sub ErrorPrint {
	my($message) = @_;
	my $html = &ReadTemplate("./template/admin/error2.html");
	$html =~ s/\$error\$/$message/ig;
	$html = &CopyRight($html);
	my $content_length = length $html;
	print "Content-Type: text/html; charset=Shift_JIS\n";
	print "Content-Length: ${content_length}\n";
	print "\n";
	print $html;
	exit;
}

sub ErrorPrint2 {
	my($message) = @_;
	print "Content-Type: text/plain; charset=Shift_JIS\n";
	print "\n";
	print $message;
	exit;
}

sub GetThisFileName {
	my $string;
	if($ENV{'SCRIPT_NAME'}) {
		$string = $ENV{'SCRIPT_NAME'};
	} elsif($ENV{'REQUEST_URI'}) {
		$string = $ENV{'REQUEST_URI'};
	} else {
		return 'admin.cgi';
	}
	my($part) = split(/\?/, $string);
	my @parts = split(/\//, $part);
	my $script_name = pop @parts;
	return $script_name;
}

sub GetCookie {
    #Cookie=CookielzɊi[B
    my @pairs = split(/\;\s*/, $ENV{'HTTP_COOKIE'});
    #Cookiei[Azz%cookies`B
    my %cookies;
    for my $pair (@pairs) {
        #Cookie=Cookiel = ŕāAXJ[ϐɊi[B
        my($name, $value) = split(/=/, $pair);
        #CookielURLfR[hB
        $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C",hex($1))/eg;
        $value =~ s/\+/ /g;
        #Azz%cookiesɊi[B
        $cookies{$name} = $value;
    }
    #Cookiei[Azz%cookiesԂB
    return %cookies;
}

sub ClearCookie {
    my($name) = @_;
    #CookieL 1970/1/1 00:00:00 ɃZbgB
    my $expire = 'Thu, 01-Jan-1970 00:00:00 GMT';
    #Set-Cookiewb_[𐶐B
    #Cookiel͉łǂ̂ŁAł clear ƂB
    my $cookie_header = "Set-Cookie: $name=clear; expires=$expire;";
    #Set-Cookiewb_[̍ŌɉsB
    $cookie_header .= "\n";
    #Set-Cookiewb_[ԂB
    return $cookie_header;
}

sub DecodeSirialKey {
	my($sirial) = @_;
	if($sirial eq '') {return;}
	if($sirial =~ /[^0-9a-zA-Z\-\t\s]/) {
		return;
	}
	my @parts = split(/[\-\t\s]/, $sirial);
	my $sirial;
	for my $part (@parts) {
		if($part eq '') {return;}
		$part = unpack("n", pack("H4", $part));
		$part = sqrt($part);
		if($part % 1) {
			return;
		}
		$part = sprintf("%02lx", $part);
		$sirial .= $part;
	}
	$sirial = hex $sirial;
	my $license = ($sirial - 12345) / 98765;
	if($license <= 0) {return;}
	my $int_value = int $license;
	if( $license - $int_value != 0 ) {return;}
	return $license;
}

sub ReadTextFile {
	my($file) = @_;
	my $size = -s $file;
	if(!open(IN, "$file")) {
		&ErrorPrint2("$file I[vł܂łB : $!");
	}
	binmode(IN);
	my $string;
	sysread(IN, $string, $size);
	close(IN);
	$string = &UnifyReturnCode($string);
	return $string;
}
